Scriptname RDS_HjerimScript extends Quest  conditional
;CONSTANTS
RDS_PlayerApproachScript Property Main auto
RDS_NPCApproachScript Property Secondary auto
RDS_RelationshipScript Property RelScript auto
referenceAlias Property partner auto
referenceAlias Property visitor auto
MiscObject Property WineBottle01AEmpty auto
MiscObject Property WineBottle01BEmpty auto
MiscObject Property WineBottle02AEmpty auto
MiscObject Property WineBottle02BEmpty auto
MiscObject Property dunAlftandEmptySkoomaBottle auto
actor property visitorNice01 auto
actor property visitorNice02 auto
actor property visitorSleazy01 auto
actor property visitorSleazy02 auto
cell property homeCell auto
SexLabFramework property SexLab auto
ObjectReference property Bed auto
quest property RDS_Prison auto
RDS_MCM property MCM auto
objectreference property hay01 auto
objectreference property hay02 auto
objectreference property hay03 auto
objectreference property hay04 auto
objectreference property hay05 auto
objectreference property cobweb01 auto
objectreference property cobweb02 auto
objectreference property cobweb03 auto
objectreference property bottle01 auto
objectreference property bottle02 auto
objectreference property bottle03 auto
objectreference property bottle04 auto
objectreference property bottle05 auto

;INTERNALS
string Property personality auto hidden
int Property PartnerPers auto hidden conditional
float Property travelingCooldown auto hidden
float Property visitorCooldown auto hidden
bool property traveling = false auto hidden
int property threesome = 0 auto hidden conditional
int property dirtlevel = 0 auto hidden conditional ; rannging from 0 (clean) to 10 (dirty)

Event OnUpdateGameTime()
if MCM.ON
	Utility.Wait(0.1)
	cell currentCell = partner.getRef().getParentCell()
	actor PartnerRef = partner.getRef() as Actor
	
	; LITTERING
	if MCM.litter && getStage() <= 10 && currentCell == homeCell && Utility.RandomInt(1,6) <= 1
		miscObject litter
		int roll = utility.RandomInt(1, 4)
		if roll == 1
			litter = WineBottle01AEmpty
		elseIf roll == 2
			litter = WineBottle01BEmpty
		elseIf roll == 3
			litter = WineBottle02AEmpty
		else
			litter = WineBottle02BEmpty
		endif
		if personality == "choleric" && Utility.RandomInt(1, 100) <= 75
			partner.getRef().placeAtMe(litter)
		elseif personality == "confidant" && Utility.RandomInt(1, 100) <= 50
			partner.getRef().placeAtMe(litter)		
		elseif personality == "realistic" && Utility.RandomInt(1, 100) <= 40
			partner.getRef().placeAtMe(litter)
		endif
	endif

	; VISITOR
	; comming
	if getStage() == 0 && (Utility.getCurrentGameTime() - visitorCooldown) >= 2 && Utility.RandomInt(1, 100) <= 7 && currentCell == homeCell
		visitorCooldown = Utility.getCurrentGameTime()
		int random
		if personality == "choleric" || personality == "confidant"
			random = Utility.RandomInt(1, 2)
			if random == 1 && partnerRef != visitorSleazy01
				visitor.forceRefTo(visitorSleazy01)
			elseIf random == 2 && partnerRef != visitorSleazy02
				visitor.forceRefTo(visitorSleazy02)
			endif
		elseIf personality == "realistic"
			random = Utility.RandomInt(1, 4)
			if random == 1 && partnerRef != visitorSleazy01
				visitor.forceRefTo(visitorSleazy01)
			elseIf random == 2 && partnerRef != visitorSleazy02
				visitor.forceRefTo(visitorSleazy02)
			elseIf random == 3 && partnerRef != visitorNice01
				visitor.forceRefTo(visitorNice01)
			elseIf random == 4 && partnerRef != visitorNice02
				visitor.forceRefTo(visitorNice02)
			endif		
		else
			random = Utility.RandomInt(1, 2)
			if random == 1 && partnerRef != visitorNice01
				visitor.forceRefTo(visitorNice01)
			elseif random == 2 && partnerRef != visitorNice02
				visitor.forceRefTo(visitorNice02)
			endif
		endif
		setStage(10)
	endif
	
	;leaving
	If getStage() == 10 && (Utility.getCurrentGameTime() - visitorCooldown)*24 >= 4
		visitorCooldown = Utility.getCurrentGameTime()
		visitor.clear()
		reset()
		setStage(0)
	endif
	
	; TRAVELING
	; leaving
		if getStage() == 0 && (Utility.getCurrentGameTime() - travelingCooldown) >= 4 && Utility.RandomInt(1, 100) <= 5 && currentCell == homeCell
			relScript.whiterunTravel = true
		endif
		
	; retuning	
		if getStage() == 30 && (Utility.getCurrentGameTime() - travelingCooldown) >= 3 && Utility.RandomInt(1, 100) <= 8 && !RDS_Prison.isRunning()
			setStage(40)
		endif
		
	dirtlevel = updateDirtLevel()
endif
endEvent

function getPersonality()
	int index = main.NPC_ID.find(partner.getRef() as Actor)
	personality = main.NPC_Personality[index]
	if personality == "choleric"
		PartnerPers = 1
	elseIf personality == "confidant"
		PartnerPers = 2
	elseIf personality == "realistic"
		PartnerPers = 3
	elseIf personality == "shy"
		PartnerPers = 4
	else
		PartnerPers = 5
	endif
endFunction

Function Action()
	RegisterForModEvent("AnimationEnd_sexyTime", "sexyTime")

		actor[] sexActors = new actor[3]

		if SexLab.getGender(Game.getPlayer()) == 1 || SexLab.getGender(Game.getPlayer()) == SexLab.getGender(partner.getActorRef())
			sexActors[0] = Game.getPlayer()
			sexActors[1] = (Partner.getRef() as Actor)
			sexActors[2] = (visitor.getRef() as Actor)
		else
			sexActors[0] = (Partner.getRef() as Actor)
			sexActors[1] = Game.getPlayer()
			sexActors[2] = (visitor.getRef() as Actor)
		endif

		sslBaseAnimation[] anims		

		SexLab.StartSex(SexActors, Anims, AllowBed = true, CenterOn = Bed ,Hook = "sexyTime")

endfunction

event Finished (string eventName, string arg, float argNum, form sender)
	reset()
	setStage(10)
endEvent

int function UpdateDirtLevel()

	int dirt = 0
	
	if !hay01.isDisabled()
		dirt += 1
	endif
	if !hay02.isDisabled()
		dirt += 1
	endif
	if !hay03.isDisabled()
		dirt += 1
	endif
	if !hay04.isDisabled()
		dirt += 1
	endif
	if !hay05.isDisabled()
		dirt += 1
	endif

	if !cobweb01.isDisabled()
		dirt += 1
	endif
	if !cobweb02.isDisabled()
		dirt += 1
	endif
	if !cobweb03.isDisabled()
		dirt += 1
	endif
	
	Objectreference aThing
	int iIndex = homeCell.getNumRefs(32)
	
	While iIndex > 0	
		iIndex -= 1
		aThing = homeCell.getNthRef(iIndex, 32)
		If !aThing.isDisabled() && aThing == bottle01 || aThing == bottle02 || aThing == bottle03 || aThing == Bottle04 || aThing == Bottle05
				dirt += 1
		endif
	endWhile

	if dirt > 10
		dirt = 10
	elseIf dirt < 0
		dirt = 0
	endif
	
	return dirt
endFunction

Event OnUpdate()
	If partner.getRef().getParentCell() == homeCell && getstage() == 40
		UnregisterForUpdate()
		reset()
		setstage(0)
	endif
endEvent