Scriptname RDS_LetterScript extends Quest  

;CONSTANTS
quest Property home_Breezehome auto
quest Property home_Hjerim auto
quest Property home_Honeyside auto
quest Property home_ProudspireManor auto
quest Property home_VlindrelHall auto
referenceAlias property partner_Breezehome auto
referenceAlias property partner_Hjerim auto
referenceAlias property partner_Honeyside auto
referenceAlias property partner_ProudspireManor auto
referenceAlias property partner_VlindrelHall auto
referenceAlias property partner auto
RDS_playerApproachScript property main auto
RDS_MCM property MCM auto
book property letter_nice auto
book property letter_mean auto
book property letter_lovely auto
book property letter_sleazy auto
book property letter_prison auto
quest property RDS_MeanLetter auto
quest property RDS_SleazyLetter auto
quest property RDS_NiceLetter auto
quest property RDS_LovelyLetter auto
quest property RDS_PrisonLetter auto
quest property RDS_Prison auto

;INTERNALS
bool property doOnce = false auto hidden
float property letterCooldown auto hidden
book property myLetter auto hidden

Event OnInit()
if !doOnce
	RegisterForUpdateGameTime(24)
	letterCooldown = utility.getCurrentGameTime()
	doOnce = true
endif

EndEvent

Event OnUpdateGameTime()
	utility.wait(0.1)
	if MCM.On && (Utility.GetCurrentGameTime() - letterCooldown) > 3 && Utility.RandomInt(1, 100) <= 30
		letterCooldown = Utility.GetCurrentGameTime()
		quest[] myQuests = new Quest[5]
		int index = 0
		
		if !RDS_MeanLetter.isRunning() && !RDS_SleazyLetter.isRunning() && !RDS_NiceLetter.isRunning() && !RDS_LovelyLetter.isRunning() && !RDS_Prison.isRunning()
			if home_Breezehome.getStage() == 30
				myQuests[index] = home_Breezehome
				index += 1
			endif
			if home_Hjerim.getStage() == 30
				myQuests[index] = home_Hjerim
				index += 1
			endif
			if home_Honeyside.getStage() == 30
				myQuests[index] = home_Honeyside
				index += 1
			endif
			if home_ProudspireManor.getStage() == 30
				myQuests[index] = home_ProudspireManor
				index += 1
			endif
			if home_VlindrelHall.getStage() == 30
				myQuests[index] = home_VlindrelHall
				index += 1
			endif
		endif

		if index > 0
			int random = Utility.RandomInt(1, index)

			quest activeQuest = myQuests[random - 1]

			If activeQuest == home_Breezehome
				partner.clear()
				partner.forceRefTo(partner_Breezehome.getActorRef())
			elseif activeQuest == home_Hjerim
				partner.clear()
				partner.forceRefTo(partner_Hjerim.getActorRef())
			elseif activeQuest == home_Honeyside
				partner.clear()
				partner.forceRefTo(partner_Honeyside.getActorRef())
			elseif activeQuest == home_ProudspireManor
				partner.clear()
				partner.forceRefTo(partner_ProudspireManor.getActorRef())
			elseif activeQuest == home_VlindrelHall
				partner.clear()
				partner.forceRefTo(partner_VlindrelHall.getActorRef())
			endif

			int NPC = main.NPC_ID.find(partner.getActorRef())
			string personality = main.NPC_personality[NPC]
			
			if personality == "choleric"
				If Utility.randomInt(1, 100) <= 85
					If Utility.randomInt(1,2) == 1
						myletter = letter_mean
						RDS_MeanLetter.start()
					else
						myletter = letter_sleazy
						RDS_SleazyLetter.start()
					endif
				else
					myLetter = letter_prison
					RDS_PrisonLetter.start()
				endif
			elseif personality == "confidant"
				If Utility.randomInt(1, 100) <= 90
					If Utility.randomInt(1,2) == 1
						myletter = letter_lovely
						RDS_LovelyLetter.start()
					else
						myletter = letter_sleazy
						RDS_SleazyLetter.start()
					endif		
				else
					myLetter = letter_prison
					RDS_PrisonLetter.start()
				endif
			elseif personality == "realistic"
				If Utility.randomInt(1, 100) <= 95
					If Utility.randomInt(1,2) == 1
						myletter = letter_nice
						RDS_NiceLetter.start()
					else
						myletter = letter_sleazy
						RDS_SleazyLetter.start()
					endif
				else
					myLetter = letter_prison
					RDS_PrisonLetter.start()
				endif
			elseif personality == "shy"
				If Utility.randomInt(1,2) == 1
					myletter = letter_nice
					RDS_NiceLetter.start()
				else
					myletter = letter_sleazy
					RDS_SleazyLetter.start()
				endif
			elseif personality == "sophisticated"
				If Utility.randomInt(1,2) == 1
					myletter = letter_mean
					RDS_MeanLetter.start()
				else
					myletter = letter_lovely
					RDS_LovelyLetter.start()
				endif
			endif
		endif
	endif	
EndEvent