Scriptname RDS_NPCApproachScript extends Quest  

;PROPERTIES
;scripts
RDS_PlayerApproachScript Property Main Auto
SexLabFramework Property SexLab Auto
RDS_MCM Property MCM  Auto 

;quests (all possible scenes)
Quest property RDS_sceneBlackmail auto
Quest property RDS_sceneCheating auto
Quest property RDS_sceneCoercion auto
Quest property RDS_sceneCourting auto
Quest property RDS_sceneDrinking auto
Quest property RDS_sceneFriendsWithBenefits auto
Quest property RDS_sceneInsulting auto
Quest property RDS_sceneKidnap auto
Quest property RDS_sceneLecturing auto
Quest property RDS_sceneMakingDrunk auto
Quest property RDS_scenePayForSex auto
Quest property RDS_scenePickup auto
Quest property RDS_sceneQuicky auto
Quest Property RDS_DialogueQuest Auto 
quest property RDS_Relationships auto

;actor
Actor Property Player auto
Actor[] Property NPC Auto hidden
actor Property thisNPC auto hidden
actor property randomNPC auto hidden

;constants
STATIC Property xMarker  Auto  
keyword Property ActorTypeNPC auto
ReferenceAlias Property ActiveNPC  Auto  
AssociationType Property Spouse  Auto
faction property RDS_noApproach auto

;utility values
int Property x auto hidden
GlobalVariable Property RDS_NPCapproachcooldown  Auto  
float property lastUpdate auto hidden  
bool Property firstInstall auto
bool Property sceneIsRunning = false auto hidden

;voice types (for assigning personalities)
VoiceType property FemaleArgonian Auto
VoiceType property FemaleCommander Auto
VoiceType property FemaleCommoner Auto
VoiceType property FemaleCondescending Auto
VoiceType property FemaleCoward Auto
VoiceType property FemaleDarkElf Auto
VoiceType property FemaleElfHaughty Auto
VoiceType property FemaleEvenToned Auto
VoiceType property FemaleKhajiit Auto
VoiceType property FemaleNord Auto
VoiceType property FemaleOldGrumpy Auto
VoiceType property FemaleOldKindly Auto
VoiceType property FemaleOrc Auto
VoiceType property FemaleShrill Auto
VoiceType property FemaleSoldier Auto
VoiceType property FemaleSultry Auto
VoiceType property FemaleYoungEager Auto
VoiceType property MaleArgonian Auto
VoiceType property MaleBandit Auto
VoiceType property MaleBrute Auto
VoiceType property MaleCommander Auto
VoiceType property MaleCommoner Auto
VoiceType property MaleCommonerAccented Auto
VoiceType property MaleCondescending Auto
VoiceType property MaleCoward Auto
VoiceType property MaleDarkElf Auto
VoiceType property MaleDrunk Auto
VoiceType property MaleElfHaughty Auto
VoiceType property MaleEvenToned Auto
VoiceType property MaleEvenTonedAccented Auto
VoiceType property MaleForsworn Auto
VoiceType property MaleGuard Auto
VoiceType property MaleKhajiit Auto
VoiceType property MaleNord Auto
VoiceType property MaleNordCommander Auto
VoiceType property MaleOldGrumpy Auto
VoiceType property MaleOldKindly Auto
VoiceType property MaleOrc Auto
VoiceType property MaleSlyCynical Auto
VoiceType property MaleSoldier Auto
VoiceType property MaleWarlock Auto
VoiceType property MaleYoungEager Auto

Event OnInit()
	If firstInstall
		RegisterForUpdate(180)

		NPC = new actor[128]

		firstInstall = false
	endif
endevent

Event OnUpdate()
	
	Utility.Wait(0.1)
	
	float time = Utility.GetCurrentGameTime()

	If time >= lastUpdate && MCM.On && MCM.approachToggle != "No approaches" && !sceneIsRunning												;check if the cooldown has run out, if not do nothing

		;Debug.Notification("Approache Update!")
	
		float cooldown = MCM.cooldown									;resetting the cooldown
		time += (cooldown/24)
		lastUpdate = time
		RDS_NPCapproachcooldown.SetValue(time)

		x = 0
		scanCell(Player.getParentCell())										;scaning the current player cell, when in interor this is the only cell we need to scan, (function is further down in this script)
		;Utility.Wait(0.5)

		If !Player.isInInterior()												;to cover more ground outside, the following code scans a 3x3 grid of exterior cells around the player
			ObjectReference Marker1 = Player.placeAtMe(xMarker)
			ObjectReference Marker2 = Player.placeAtMe(xMarker)			;1 2 3
			ObjectReference Marker3 = Player.placeAtMe(xMarker)			;4 0 5
			ObjectReference Marker4 = Player.placeAtMe(xMarker)			;6 7 8 
			ObjectReference Marker5 = Player.placeAtMe(xMarker)
			ObjectReference Marker6 = Player.placeAtMe(xMarker)
			ObjectReference Marker7 = Player.placeAtMe(xMarker)
			ObjectReference Marker8 = Player.placeAtMe(xMarker)

			Marker1.moveTo(Player, afXOffset = -4096.0, afYOffset = 4096.0)
			Marker2.moveTo(Player, afXOffset = 0.0, afYOffset = 4096.0)
			Marker3.moveTo(Player, afXOffset = 4096.0, afYOffset = 4096.0)

			Marker4.moveTo(Player, afXOffset = -4096.0, afYOffset = 0.0)
			Marker5.moveTo(Player, afXOffset = 4096.0, afYOffset = 0.0)

			Marker6.moveTo(Player, afXOffset = -4096.0, afYOffset = -4096.0)
			Marker7.moveTo(Player, afXOffset = 0.0, afYOffset = -4096.0)
			Marker8.moveTo(Player, afXOffset = 4096.0, afYOffset = -4096.0)
			
			scanCell(Marker1.getParentCell())
			;Utility.Wait(0.5)
			scanCell(Marker2.getParentCell())
			;Utility.Wait(0.5)
			scanCell(Marker3.getParentCell())
			;Utility.Wait(0.5)
			scanCell(Marker4.getParentCell())
			;Utility.Wait(0.5)
			scanCell(Marker5.getParentCell())
			;Utility.Wait(0.5)
			scanCell(Marker6.getParentCell())
			;Utility.Wait(0.5)
			scanCell(Marker7.getParentCell())
			;Utility.Wait(0.5)
			scanCell(Marker8.getParentCell())
			;Utility.Wait(0.5)
		endif

		int partner = 0														;sorting all scanned NPC into caegories, to see which scenes or approaches can be triggered
		int pickup = 0
		int quicky = 0
		int friendsWithBenefits = 0
		int suitor = 0														;currently unsued, but planned for reoccuring suitors or stalker scenes
		int cheating = 0
		int courting = 0
		int pay = 0
		int makingDrunk = 0
		int coercion = 0	
		int drinking = 0
		int blackmail = 0
		int lecture = 0
		int insulting = 0
		int kidnap = 0
		int dialogue = 0

		actor[] partnerActor = new actor[100]
		actor[] blackmailActor = new actor[100]
		actor[] CheatingActor = new actor[100]
		actor[] coercionActor = new actor[100]
		actor[] courtingActor = new actor[100]
		actor[] drinkingActor = new actor[100]
		actor[] friendsWithBenefitsActor = new actor[100]
		actor[] insultingActor = new actor[100]
		actor[] kidnapActor = new actor[100]
		actor[] lecturingActor = new actor[100]
		actor[] makingDrunkActor = new actor[100]
		actor[] payForSexActor = new actor[100]
		actor[] pickupActor = new actor[100]
		actor[] quickyActor = new actor[100]
		actor[] dialogueActor = new actor[100]


		int a = 0
		int b = 0
		string RelStat
		bool m        ;morality of the NPC 
		int NPCgender
		bool sexAllowed = false
		string sexuality
		int playerGender
		float currentTime = Utility.getCurrentGameTime()

		while a < 128				; check each found NPC if it matches a scenes requirements, one NPC can fit for multiple scenes at once

			if NPC[a] != none		; Array slot it not empty
				if !NPC[a].isInFaction(RDS_noApproach)
					NPCgender = SexLab.getGender(NPC[a])
					
					if ((NPCgender == 0 && MCM.approachGender == "male") || (NPCgender == 1 && MCM.approachGender == "female")) || MCM.approachGender == "both"		; check if NPC has the right gender

						
						b = Main.NPC_ID.find(NPC[a])															; try to find the NPC in RDS storage
			
						if b < 0																				; any NPC that has not been setup by RDS gets setup
							b = Setup_NPC(NPC[a])

						endif

						If Main.NPC_cooldown[b] <= currentTime							; check if NPCs cooldown has run out
							If (Main.NPC_relationshipStatus[b] == "partner" && MCM.approachToggle == "only partners and FWB") || (Main.NPC_relationshipStatus[b] == "friendsWithBenefits" && MCM.approachToggle == "only partners and FWB") || MCM.approachToggle != "only partners and FWB"
								
									sexuality = Main.NPC_sexuality[b]
									
									if (sexuality == "hetero" && (MCM.approachSexuality == "hetero" || MCM.approachSexuality == "hetero + bi")) || (sexuality == "homo" && (MCM.approachSexuality == "homo" || MCM.approachSexuality == "homo + bi")) || (sexuality == "bi"  && (MCM.approachSexuality == "bi" || MCM.approachSexuality == "hetero + bi" || MCM.approachSexuality == "homo + bi")) || MCM.approachSexuality == "unspecified"

										dialogueActor[dialogue] = NPC[a]
										dialogue += 1
									
										if NPC[a].getActorValue("morality") >= 2												;get the npcs morality to sort it into matching quests
											m = true
										else
											m = false
										endif
										
										playerGender = SexLab.getGender(player) 														; making sure that only NPC whose sexuality matches the player gender are choosen for sexual scenes
										
										if (playerGender == NPCgender && sexuality == "Homo") || (playerGender != NPCgender && sexuality == "Hetero") || sexuality == "Bi"
											sexAllowed = true
										endif
										
										RelStat = Main.NPC_relationshipStatus[b]												; checking NPCs internal relationship towards the player
										
										If RelStat == "partner"
											if sexAllowed
												partnerActor[partner] = NPC[a]							
												partner += 1
											endif
										elseIf RelStat == "lover"
											if sexAllowed
												if !m
													pickupActor[pickup] = NPC[a]
													pickup += 1
												else
													quickyActor[quicky] = NPC[a]
													quicky += 1
												endif
											endif
										elseIf RelStat == "friendsWithBenefits"
											if sexAllowed
												friendsWithBenefitsActor[friendsWithBenefits] = NPC[a]
												friendsWithBenefits += 1
											endif
										elseIf RelStat == "suitor"
											;suitorArray[suitor] = NPC[a]						currently is suitor unused, but planned for reoccurring love-mad or stalker npc
											;suitor += 1					
										endif

										If main.NPC_eyeWitness[b] > 0 || main.NPC_earWitness[b] > 0
											if !m
												if sexAllowed
													blackmailActor[blackmail] = NPC[a]
													blackmail += 1
												endif
											endif
										endif
										
										If NPC[a].hasAssociation(Spouse) && !NPC[a].hasAssociation(Spouse, player)			;npc is married, but not to the player
											if sexAllowed
												if !m
													cheatingActor[cheating] = NPC[a]
													cheating += 1
												endif
											endif
										elseIf !NPC[a].hasAssociation(Spouse)												;npc is not married
											if sexAllowed
												if m
													courtingActor[courting] = NPC[a]
													courting += 1
													payForSexActor[pay] = NPC[a]
													pay += 1
												endif
											endif
										endif

										int rep = main.getLocalReputation()				; find in which hold we currently are and get the specific reputaion

										If rep < 50
											if m
												lecturingActor[lecture] = NPC[a]
												lecture += 1						
											else
												insultingActor[insulting] = NPC[a]
												insulting += 1
											endif						
										else
											if sexAllowed
												if !m
													kidnapActor[kidnap] = NPC[a]
													kidnap += 1						
												endif
											endif
										endif
										
										if m
											drinkingActor[drinking] = NPC[a]
											drinking += 1						
										else
											if sexAllowed
												coercionActor[coercion] = NPC[a]
												coercion += 1
												makingDrunkActor[makingDrunk] = NPC[a]
												makingDrunk += 1
											endif
										endif
									endif
							endif
						endif
					endif
				endif
			endif
			
			a += 1
			
		endWhile
		
		quest[] validScenesArray = new quest[14]						; this codes checks which scenes have matching NPC available and fills the quest into an array
		quest[] validPreferedScenesArray = new quest[10]				
		int validScenes
		int validPreferedScenes										; prefered scenes happen more often than others (they have a deeper "story" and often involve the players partners, the normal scenes are mostly random one-off events)
		
		if blackmailActor.find(none) > 0
			validScenesArray[validScenes] = RDS_sceneBlackmail
			validScenes += 1
		endif
		if cheatingActor.find(none) > 0
			validScenesArray[validScenes] = RDS_sceneCheating
			validScenes += 1
		endif
		if coercionActor.find(none) > 0
			validScenesArray[validScenes] = RDS_sceneCoercion
			validScenes += 1
		endif
		if courtingActor.find(none) > 0
			validScenesArray[validScenes] = RDS_sceneCourting
			validScenes += 1
		endif
		if drinkingActor.find(none) > 0
			validScenesArray[validScenes] = RDS_sceneDrinking
			validScenes += 1
		endif
		if friendsWithBenefitsActor.find(none) > 0
			validPreferedScenesArray[validPreferedScenes] = RDS_sceneFriendsWithBenefits
			validPreferedScenes += 1
		endif
		if insultingActor.find(none) > 0
			validScenesArray[validScenes] = RDS_sceneInsulting
			validScenes += 1
		endif
		if kidnapActor.find(none) > 0
			validScenesArray[validScenes] = RDS_sceneKidnap
			validScenes += 1
		endif
		if makingDrunkActor.find(none) > 0
			validScenesArray[validScenes] = RDS_sceneMakingDrunk
			validScenes += 1
		endif
		if payForSexActor.find(none) > 0
			validScenesArray[validScenes] = RDS_scenePayForSex
			validScenes += 1
		endif
		if pickupActor.find(none) > 0
			validPreferedScenesArray[validPreferedScenes] = RDS_scenePickup
			validPreferedScenes += 1
		endif
		if quickyActor.find(none) > 0
			validPreferedScenesArray[validPreferedScenes] = RDS_sceneQuicky
			validPreferedScenes += 1
		endif
		if lecturingActor.find(none) > 0
			validScenesArray[validScenes] = RDS_sceneLecturing
			validScenes += 1
		endif			
		if partnerActor.find(none) > 0
			validPreferedScenesArray[validPreferedScenes] = RDS_Relationships
			validPreferedScenes += 1
		endIf
		if dialogueActor.find(none) > 0
			validScenesArray[validScenes] = RDS_dialogueQuest
			validScenes += 1
		endIf
		
		;################################################## CHOOSING A RANDOM SCENE #################################
		
		int random
		quest activeScene
		int roll = utility.randomInt(1, 100)
		if validPreferedScenesArray.find(none) > 0 && (MCM.approachToggle == "only partners and FWB" || roll > MCM.dialogueChance)				; first priority are prefered scenes, if we don't have any prefered scenes jump directly to normal scenes
			
			
			random = utility.randomInt(0, validPreferedScenes - 1)
			activeScene = validPreferedScenesArray[random]										; draw a random scene from the pool
			
			if activeScene == RDS_Relationships
				random = utility.randomInt(0, partner - 1)											; draw a random actor from the scene specific pool
				randomNPC = partnerActor[random]
			;elseif activeScene == RDS_sceneQuicky
			;	random = utility.randomInt(0, quicky - 1)
			;	randomNPC = quickyActor[random]
			;elseif activeScene == RDS_scenePickup
			;	random = utility.randomInt(0, pickup - 1)
			;	randomNPC = pickupActor[random]
			elseif activeScene == RDS_sceneFriendsWithBenefits
				random = utility.randomInt(0, friendsWithBenefits - 1)
				randomNPC = friendsWithBenefitsActor[random]			
			endif
			
			activeScene.Start()																	; start the scene and give it time to get the NPC from this scr
			sceneIsRunning = true																; each scene turns this to false on shutdown
			utility.wait(1)
			activeScene.setStage(5)																; trigger the forcegreet
			
			;Debug.Notification("Prefered-Scene started with: " + randomNPC.getLeveledActorBase().getName())
			
		elseIf validScenesArray.find(none) > 0													; second priority are normal scenes including the generic dialogue scene
	
			RDS_DialogueQuest.start()							;ATM ONLY START THE DIALOGUE SCENE
			
			random = utility.randomInt(0, dialogue - 1)
			randomNPC = dialogueActor[random]
			
			RDS_DialogueQuest.setStage(5)
			sceneIsRunning = true
	
			;Debug.Notification("Generic Dialogue started with: " + randomNPC.getLeveledActorBase().getName())
	
	;		random = utility.randomInt(0, validScenes)
	;		activeScene = validScenesArray[random]		
			
	;		if activeScene == RDS_dialogueQuest						PREPARED FOR LATER
	;			random = utility.randomInt(0, dialogue - 1)
	;			randomNPC = dialogueActor[random]
	;		elseif activeScene == RDS_sceneLecturing
	;			random = utility.randomInt(0, lecture - 1)
	;			randomNPC = lecturingActor[random]
	;		elseif activeScene == RDS_scenePayForSex
	;			random = utility.randomInt(0, pay - 1)
	;			randomNPC = payForSexActor[random]
	;		elseif activeScene == RDS_sceneMakingDrunk
	;			random = utility.randomInt(0, makingDrunk - 1)
	;			randomNPC = makingDrunkActor[random]
	;		elseif activeScene == RDS_sceneKidnap
	;			random = utility.randomInt(0, kidnap - 1)
	;			randomNPC = kidnapActor[random]
	;		elseif activeScene == RDS_sceneInsulting			
	;			random = utility.randomInt(0, insulting - 1)
	;			randomNPC = insultingActor[random]
	;		elseif activeScene == RDS_sceneDrinking
	;			random = utility.randomInt(0, drinking - 1)
	;			randomNPC = drinkingActor[random]
	;		elseif activeScene == RDS_sceneCourting
	;			random = utility.randomInt(0, courting - 1)
	;			randomNPC = courtingActor[random]
	;		elseif activeScene == RDS_sceneCoercion
	;			random = utility.randomInt(0, coercion - 1)
	;			randomNPC = coercionActor[random]
	;		elseif activeScene == RDS_sceneCheating
	;			random = utility.randomInt(0, cheating - 1)
	;			randomNPC = cheatingActor[random]
	;		elseif activeScene == RDS_sceneBlackmail
	;			random = utility.randomInt(0, blackmail - 1)
	;			randomNPC = blackmailActor[random]
	;		endif
			
	;		activeScene.Start()
	;		sceneIsRunning = true
	;		utility.wait(1)
	;		activeScene.setStage(5)
			
		endif
	endIf
	
	int iClean = 0
	While iClean < 128
		NPC[iClean] = none
		iClean += 1
	endWhile
	
EndEvent

Function scanCell(Cell myCell)											;all NPC are filtered by their voicetype and consecutively stoared into an array
		int iIndex = myCell.getNumRefs(43)
		X = NPC.find(none)												;find the first empty slot and fill from there
		While iIndex > 0
		
			iIndex -= 1
			thisNPC = myCell.getNthRef(iIndex, 43) as Actor
			
			If thisNPC.hasKeyword(ActorTypeNPC)
				If !thisNPC.isDead() && !thisNPC.isInCombat() && !thisNPC.isHostileToActor(player) && !thisNPC.isFlying() && !thisNPC.isDisabled() && !SexLab.isActorActive(thisNPC) && !thisNPC.isChild() && thisNPC != player && thisNPC.getActorBase().getName() != ""
					NPC[x] = thisNPC
					x += 1
				endif
			endif
		endWhile
endFunction

Function CleanNPCArray()
	int y = 0
	while y < 256
		NPC[y] = none
		y += 1
	endwhile
	return
endFunction

int Function Setup_NPC(actor myNPC)
		string Personality
		string Trait1
		string sexuality
		int Affection 

		int pos = Main.NPC_ID.find(none)
		If pos < 0																								 ;array full
			Debug.Notification("WARNING! RDS stoarge array full! No further NPC can be saved!")
			pos = -1
		else

			Main.NPC_ID[pos] = myNPC

			int Roll = Utility.RandomInt(1, 100)
			if myNPC.getVoiceType() == FemaleArgonian
				if roll <= 5
					Personality = "Shy"		
				elseif roll <= 25
					Personality = "Sophisticated"
				elseif roll <= 45
					Personality = "Realistic"
				elseif roll <= 65
					Personality = "Confidant"
				else
					Personality = "Choleric"
				endif
			elseif myNPC.getVoiceType() == FemaleCommander
				if roll <= 0
					Personality = "Shy"
				elseif roll <= 30
					Personality = "Sophisticated"
				elseif roll <= 50
					Personality = "Realistic"
				elseif roll <= 80
					Personality = "Confidant"
				else
					Personality = "Choleric"
				endif
			elseif myNPC.getVoiceType() == FemaleCommoner
				if roll <= 35
					Personality = "Shy"
				elseif roll <= 45
					Personality = "Sophisticated"
				elseif roll <= 65
					Personality = "Realistic"				
				elseif roll <= 85
					Personality = "Confidant"
				else
					Personality = "Choleric"
				endif
			elseif myNPC.getVoiceType() == FemaleCondescending
				if roll <= 15
					Personality = "Shy"
				elseif roll <= 50
					Personality = "Sophisticated"
				elseif roll <= 70
					Personality = "Realistic"				
				elseif roll <= 90
					Personality = "Confidant"
				else
					Personality = "Choleric"
				endif	
			elseif myNPC.getVoiceType() == FemaleCoward
				if roll <= 60
					Personality = "Shy"
				elseif roll <= 80
					Personality = "Sophisticated"
				;if roll <= 0
				;	Personality = "Confidant"
				;elseif roll <= 0
				;	Personality = "Choleric"
				else
					Personality = "Realistic"
				endif
			elseif myNPC.getVoiceType() == FemaleDarkElf
				if roll <= 10
					Personality = "Shy"
				elseif roll <= 20
					Personality = "Sophisticated"
				elseif roll <= 45
					Personality = "Realistic"				
				elseif roll <= 75
					Personality = "Confidant"
				else
					Personality = "Choleric"
				endif
			elseif myNPC.getVoiceType() == FemaleElfHaughty
				if roll <= 0
					Personality = "Shy"
				elseif roll <= 75
					Personality = "Sophisticated"
				elseif roll <= 80
					Personality = "Realistic"				
				elseif roll <= 90
					Personality = "Confidant"
				else
					Personality = "Choleric"
				endif
			elseif myNPC.getVoiceType() == FemaleEvenToned
				if roll <= 25
					Personality = "Shy"
				elseif roll <= 45
					Personality = "Sophisticated"
				elseif roll <= 65
					Personality = "Realistic"				
				elseif roll <= 85
					Personality = "Confidant"
				else
					Personality = "Choleric"
				endif
			elseif myNPC.getVoiceType() == FemaleKhajiit
				if roll <= 20
					Personality = "Shy"
				elseif roll <= 50
					Personality = "Sophisticated"
				elseif roll <= 70
					Personality = "Realistic"				
				elseif roll <= 90
					Personality = "Confidant"
				else
					Personality = "Choleric"
				endif
			elseif myNPC.getVoiceType() == FemaleNord
				if roll <= 15
					Personality = "Shy"
				elseif roll <= 25
					Personality = "Sophisticated"
				elseif roll <= 50
					Personality = "Realistic"				
				elseif roll <= 25
					Personality = "Confidant"
				else
					Personality = "Choleric"
				endif
			elseif myNPC.getVoiceType() == FemaleOldGrumpy
				if roll <= 10
					Personality = "Shy"
				elseif roll <= 40
					Personality = "Sophisticated"
				elseif roll <= 65
					Personality = "Realistic"				
				elseif roll <= 75
					Personality = "Confidant"
				else
					Personality = "Choleric"
				endif	
			elseif myNPC.getVoiceType() == FemaleOldKindly
				if roll <= 30
					Personality = "Shy"
				elseif roll <= 60
					Personality = "Sophisticated"
				elseif roll <= 90
					Personality = "Realistic"				
				elseif roll <= 95
					Personality = "Confidant"
				else
					Personality = "Choleric"
				endif	
			elseif myNPC.getVoiceType() == FemaleOrc
				;if roll <= 0
				;	Personality = "Shy"
				;elseif roll <= 0
				;	Personality = "Sophisticated"
				if roll <= 10
					Personality = "Realistic"				
				elseif roll <= 50
					Personality = "Confidant"
				else
					Personality = "Choleric"
				endif
			elseif myNPC.getVoiceType() == FemaleShrill
				if roll <= 10
					Personality = "Shy"
				elseif roll <= 25
					Personality = "Sophisticated"
				elseif roll <= 50
					Personality = "Realistic"				
				elseif roll <= 75
					Personality = "Confidant"
				else
					Personality = "Choleric"
				endif	
			elseif myNPC.getVoiceType() == FemaleSoldier
				if roll <= 15
					Personality = "Shy"
				elseif roll <= 25
					Personality = "Sophisticated"
				elseif roll <= 45
					Personality = "Realistic"				
				elseif roll <= 75
					Personality = "Confidant"
				else
					Personality = "Choleric"
				endif
			elseif myNPC.getVoiceType() == FemaleSultry
				if roll <= 20
					Personality = "Shy"
				elseif roll <= 40
					Personality = "Sophisticated"
				elseif roll <= 65
					Personality = "Realistic"				
				elseif roll <= 95
					Personality = "Confidant"
				else
					Personality = "Choleric"
				endif	
			elseif myNPC.getVoiceType() == FemaleYoungEager
				if roll <= 30
					Personality = "Shy"
				elseif roll <= 40
					Personality = "Sophisticated"
				elseif roll <= 55
					Personality = "Realistic"				
				elseif roll <= 85
					Personality = "Confidant"
				else
					Personality = "Choleric"
				endif	
			elseif myNPC.getVoiceType() == MaleArgonian
				if roll <= 20
					Personality = "Shy"
				elseif roll <= 25
					Personality = "Sophisticated"
				elseif roll <= 45
					Personality = "Realistic"				
				elseif roll <= 65
					Personality = "Confidant"
				else
					Personality = "Choleric"
				endif
			elseif myNPC.getVoiceType() == MaleBandit
				if roll <= 10
					Personality = "Shy"
				;elseif roll <= 0
				;	Personality = "Sophisticated"				
				elseif roll <= 15
					Personality = "Realistic"
				elseif roll <= 35
					Personality = "Confidant"
				else
					Personality = "Choleric"
				endif	
			elseif myNPC.getVoiceType() == MaleBrute
				if roll <= 0
					Personality = "Shy"
				elseif roll <= 0
					Personality = "Sophisticated"
				elseif roll <= 15
					Personality = "Realistic"				
				elseif roll <= 40
					Personality = "Confidant"
				else
					Personality = "Choleric"
				endif	
			elseif myNPC.getVoiceType() == MaleCommander
				if roll <= 0
					Personality = "Shy"
				elseif roll <= 30
					Personality = "Sophisticated"
				elseif roll <= 50
					Personality = "Realistic"				
				elseif roll <= 75
					Personality = "Confidant"
				else
					Personality = "Choleric"
				endif	
			elseif myNPC.getVoiceType() == MaleCommoner
				if roll <= 30
					Personality = "Shy"
				elseif roll <= 40
					Personality = "Sophisticated"
				elseif roll <= 60
					Personality = "Realistic"				
				elseif roll <= 80
					Personality = "Confidant"
				else
					Personality = "Choleric"
				endif
			elseif myNPC.getVoiceType() == MaleCommonerAccented
				if roll <= 20
					Personality = "Shy"
				elseif roll <= 40
					Personality = "Sophisticated"				
				elseif roll <= 60
					Personality = "Realistic"
				elseif roll <= 80
					Personality = "Confidant"
				else
					Personality = "Choleric"
				endif
			elseif myNPC.getVoiceType() == MaleCondescending
				if roll <= 15
					Personality = "Shy"
				elseif roll <= 40
					Personality = "Sophisticated"
				elseif roll <= 55
					Personality = "Realistic"				
				elseif roll <= 80
					Personality = "Confidant"
				else
					Personality = "Choleric"
				endif
			elseif myNPC.getVoiceType() == MaleCoward
				if roll <= 60
					Personality = "Shy"
				elseif roll <= 80
					Personality = "Sophisticated"
				;elseif roll <= 0
				;	Personality = "Choleric"				
				;elseif roll <= 0
				;	Personality = "Confidant"
				else
					Personality = "Realistic"
				endif
			elseif myNPC.getVoiceType() == MaleDarkElf
				if roll <= 10
					Personality = "Shy"
				elseif roll <= 20
					Personality = "Sophisticated"
				elseif roll <= 45
					Personality = "Realistic"				
				elseif roll <= 75
					Personality = "Confidant"
				else
					Personality = "Choleric"
				endif
			elseif myNPC.getVoiceType() == MaleDrunk
				if roll <= 20
					Personality = "Shy"
				elseif roll <= 25
					Personality = "Sophisticated"				
				elseif roll <= 45
					Personality = "Realistic"
				elseif roll <= 65
					Personality = "Confidant"
				else
					Personality = "Choleric"
				endif
			elseif myNPC.getVoiceType() == MaleElfHaughty
				if roll <= 0
					Personality = "Shy"
				elseif roll <= 60
					Personality = "Sophisticated"
				elseif roll <= 65
					Personality = "Realistic"				
				elseif roll <= 95
					Personality = "Confidant"
				else
					Personality = "Choleric"
				endif
			elseif myNPC.getVoiceType() == MaleEvenToned
				if roll <= 25
					Personality = "Shy"
				elseif roll <= 45
					Personality = "Sophisticated"
				elseif roll <= 65
					Personality = "Realistic"				
				elseif roll <= 85
					Personality = "Confidant"
				else
					Personality = "Choleric"
				endif
			elseif myNPC.getVoiceType() == MaleEvenTonedAccented
				if roll <= 25
					Personality = "Shy"
				elseif roll <= 45
					Personality = "Sophisticated"
				elseif roll <= 65
					Personality = "Realistic"				
				elseif roll <= 85
					Personality = "Confidant"
				else
					Personality = "Choleric"
				endif	
			elseif myNPC.getVoiceType() == MaleForsworn
				if roll <= 15
					Personality = "Shy"
				elseif roll <= 20
					Personality = "Sophisticated"
				elseif roll <= 40
					Personality = "Realistic"				
				elseif roll <= 60
					Personality = "Confidant"
				else
					Personality = "Choleric"
				endif
			elseif myNPC.getVoiceType() == MaleGuard
				if roll <= 10
					Personality = "Shy"
				elseif roll <= 20
					Personality = "Sophisticated"
				elseif roll <= 45
					Personality = "Realistic"				
				elseif roll <= 65
					Personality = "Confidant"
				else
					Personality = "Choleric"
				endif
			elseif myNPC.getVoiceType() == MaleKhajiit
				if roll <= 20
					Personality = "Shy"
				elseif roll <= 50
					Personality = "Sophisticated"				
				elseif roll <= 70
					Personality = "Realistic"				
				elseif roll <= 90
					Personality = "Confidant"
				else
					Personality = "Choleric"
				endif
			elseif myNPC.getVoiceType() == MaleNord
				if roll <= 15
					Personality = "Shy"
				elseif roll <= 25
					Personality = "Sophisticated"
				elseif roll <= 50
					Personality = "Realistic"				
				elseif roll <= 75
					Personality = "Confidant"
				else
					Personality = "Choleric"
				endif
			elseif myNPC.getVoiceType() == MaleNordCommander
				if roll <= 0
					Personality = "Shy"
				elseif roll <= 30
					Personality = "Sophisticated"
				elseif roll <= 50
					Personality = "Realistic"				
				elseif roll <= 70
					Personality = "Confidant"
				else
					Personality = "Choleric"
				endif
			elseif myNPC.getVoiceType() == MaleOldGrumpy
				if roll <= 10
					Personality = "Shy"
				elseif roll <= 40
					Personality = "Sophisticated"
				elseif roll <= 65
					Personality = "Realistic"				
				elseif roll <= 75
					Personality = "Confidant"
				else
					Personality = "Choleric"
				endif
			elseif myNPC.getVoiceType() == MaleOldKindly
				if roll <= 30
					Personality = "Shy"
				elseif roll <= 60
					Personality = "Sophisticated"
				elseif roll <= 90
					Personality = "Realistic"				
				elseif roll <= 95
					Personality = "Confidant"
				else
					Personality = "Choleric"
				endif
			elseif myNPC.getVoiceType() == MaleOrc
				if roll <= 5
					Personality = "Shy"
				;elseif roll <= 0
				;	Personality = "Sophisticated"
				elseif roll <= 15
					Personality = "Realistic"				
				elseif roll <= 55
					Personality = "Confidant"
				else
					Personality = "Choleric"
				endif
			elseif myNPC.getVoiceType() == MaleSlyCynical
				if roll <= 10
					Personality = "Shy"
				elseif roll <= 50
					Personality = "Sophisticated"
				elseif roll <= 70
					Personality = "Realistic"			
				elseif roll <= 90
					Personality = "Confidant"
				else
					Personality = "Choleric"
				endif
			elseif myNPC.getVoiceType() == MaleSoldier
				if roll <= 15
					Personality = "Shy"
				elseif roll <= 25
					Personality = "Sophisticated"
				elseif roll <= 45
					Personality = "Realistic"				
				elseif roll <= 75
					Personality = "Confidant"
				else
					Personality = "Choleric"
				endif
			elseif myNPC.getVoiceType() == MaleWarlock
				if roll <= 10
					Personality = "Shy"
				elseif roll <= 25
					Personality = "Sophisticated"
				elseif roll <= 30
					Personality = "Realistic"				
				elseif roll <= 50
					Personality = "Confidant"
				else
					Personality = "Choleric"
				endif
			elseif myNPC.getVoiceType() == MaleYoungEager
				if roll <= 35
					Personality = "Shy"
				elseif roll <= 45
					Personality = "Sophisticated"
				elseif roll <= 55
					Personality = "Realistic"				
				elseif roll <= 90
					Personality = "Confidant"
				else
					Personality = "Choleric"
				endif
			else
				if roll <= 20
					Personality = "Shy"
				elseif roll <= 40
					Personality = "Sophisticated"
				elseif roll <= 60
					Personality = "Realistic"				
				elseif roll <= 80
					Personality = "Confidant"
				else
					Personality = "Choleric"
				endif
			endIf
			
			If Utility.RandomInt(1, 100) <= MCM.trait
				Roll = Utility.Randomint(1, 100)
				
				float weightSum = MCM.traitWeightPerverted + MCM.traitWeightAbusive + MCM.traitWeightCruel + MCM.traitWeightCold + MCM.traitWeightCunning + MCM.traitWeightCharming + MCM.traitWeightRomantic + MCM.traitWeightLowSelfEsteem + MCM.traitWeightPrude
				float chance_Perverted = 100 * MCM.traitWeightPerverted/weightSum
				float chance_Abusive = 100 * MCM.traitWeightAbusive/weightSum
				float chance_Cruel = 100 * MCM.traitWeightCruel/weightSum
				float chance_Cold = 100 * MCM.traitWeightCold/weightSum
				float chance_Cunning = 100 * MCM.traitWeightCunning/weightSum
				float chance_Charming = 100 * MCM.traitWeightCharming/weightSum
				float chance_Romantic = 100 * MCM.traitWeightRomantic/weightSum
				float chance_LowSelfEsteem = 100 * MCM.traitWeightLowSelfEsteem/weightSum
				float chance_Prude = 100 * MCM.traitWeightPrude/weightSum
				
				If Roll < chance_Perverted as int																																	;11,1
					Trait1 = "perverted"
				elseif Roll < chance_Cruel + chance_Perverted as int																												;22,2
					Trait1 = "cruel"
				elseif Roll < chance_Cruel + chance_Perverted + chance_Prude as int																								;33,3
					Trait1 = "prude"
				elseif Roll < chance_Cruel + chance_Perverted + chance_Prude + chance_LowSelfEsteem as int																			;44,4
					Trait1 = "low self-esteem"
				elseif Roll < chance_Cruel + chance_Perverted + chance_Prude + chance_LowSelfEsteem + chance_cold as int															;55,5			
					Trait1 = "cold"
				elseif Roll < chance_Cruel + chance_Perverted + chance_Prude + chance_LowSelfEsteem + chance_cold + chance_Cunning as int											;66,6
					Trait1 = "cunning"
				elseif Roll < chance_Cruel + chance_Perverted + chance_Prude + chance_LowSelfEsteem + chance_cold + chance_Cunning + chance_Romantic as int						;77,7
					Trait1 = "romantic"
				elseif Roll < chance_Cruel + chance_Perverted + chance_Prude + chance_LowSelfEsteem + chance_cold + chance_Cunning + chance_Romantic + chance_Abusive as int		;88,8
					Trait1 = "abusive"
				else
					Trait1 = "charming"
				Endif
			Endif

			Roll = Utility.RandomInt(1, 100)
			
			If MCM.sexdist == "all homo"
				sexuality = "Homo"
			elseIf MCM.sexdist == "all hetero"
				sexuality = "Hetero"		
			elseIf MCM.sexdist == "all bi"
				sexuality = "Bi"
			elseIf MCM.sexdist == "equally"
				Roll = Utility.RandomInt(1, 3)
				If Roll == 1
					sexuality = "Hetero"
				elseif Roll == 2 
					sexuality = "Homo"
				else
					sexuality = "Bi"
				endif
			elseIf MCM.sexdist == "2/3 homo"
				If Roll <= 66
					sexuality = "Homo"
				else
					If Roll >= 83
						sexuality = "Hetero"
					else
						sexuality = "Bi"
					endif
				endif
			elseIf MCM.sexdist == "3/4 homo"
				If Roll <= 75
					sexuality = "Homo"
				else
					If Roll >= 88
						sexuality = "Hetero"
					else
						sexuality = "Bi"
					endif
				endif
			elseIf MCM.sexdist == "2/3 hetero"
				If Roll <= 66
					sexuality = "Hetero"
				else
					If Roll >= 83
						sexuality = "Homo"
					else
						sexuality = "Bi"
					endif
				endif
			elseIf MCM.sexdist == "3/4 hetero"
				If Roll <= 75
					sexuality = "Hetero"
				else
					If Roll >= 88
						sexuality = "Homo"
					else
						sexuality = "Bi"
					endif
				endif
			elseIf MCM.sexdist == "2/3 bi"
				If Roll <= 66
					sexuality = "Bi"
				else
					If Roll >= 83
						sexuality = "Hetero"
					else
						sexuality = "Homo"
					endif
				endif
			elseIf MCM.sexdist == "3/4 bi"
				If Roll <= 75
					sexuality = "Bi"
				else
					If Roll >= 88
						sexuality = "Hetero"
					else
						sexuality = "Homo"
					endif
				endif
			endif

			int Relation = myNPC.GetRelationShipRank(player)
			If Relation == -4
				Affection = -100
			elseif Relation == -3
				Affection = -60
			elseif Relation == -2
				Affection = -30
			elseif Relation == -1
				Affection = -10
			elseif Relation == 0
				Affection = 0
			elseif Relation == 1
				Affection = 10
			elseif Relation == 2
				Affection = 30
			elseif Relation == 3
				Affection = 80
			else
				Affection = 	100
			endif
			
			Main.NPC_homeHold[pos] = Main.getCurrentHold(player)
			Main.NPC_Personality[pos] = Personality
			Main.NPC_Trait1[pos] = Trait1
			Main.NPC_sexuality[pos] = sexuality
			Main.NPC_Affection[pos] = Affection
			Main.NPC_relationshipStatus[pos] = "Stranger"

			return pos
		endIf
endFunction


