Scriptname RDS_PlayerApproachScript extends Quest  

; CONSTANTS

SexLabFramework Property SexLab auto
RDS_NPCApproachScript Property Main auto
RDS_MCM Property MCM auto
keyword Property ActiveTypeNPC auto
keyword Property ArmorCuirass auto
keyword Property ClothingBody auto
static property xMarker auto
faction property currentFollowerFaction auto
Faction Property HousecarlMarkarthCrimeFaction  Auto  
Faction Property HousecarlSolitudeCrimeFaction  Auto  
Faction Property HousecarlRiftenCrimeFaction  Auto  
Faction Property HousecarlWhiterunCrimeFaction  Auto  
Faction Property HousecarlWindhelmCrimeFaction  Auto
Actor Property playerRef auto  
Faction property Rds_breezehome auto
Faction property Rds_hjerim auto
Faction property Rds_honeyside auto
Faction property Rds_proudspiremanor auto
Faction property Rds_vlindrelhall auto
Quest property PartnerWR auto
Quest property PartnerWH auto
Quest property PartnerRF auto
Quest property PartnerSO auto
Quest property PartnerMK auto
Spell Property RDS_DebugSpell auto
Spell Property RDS_BlockActorSpell auto
RDS_playerArmorUnequipScript Property playerArmorScript auto

; reference locations for the holds walled city
location property windhelmLocation auto
location property falkreathLocation auto
location property solitudeLocation auto
location property morthalLocation auto
location property dawnstarLocation auto
location property markarthLocation auto
location property riftenLocation auto
location property whiterunLocation auto
location property winterholdLocation auto
location property riverwoodLocation auto
WorldSpace Property WhiterunWorld auto
WorldSpace Property WindhelmWorld auto
WorldSpace Property SolitudeWorld auto
WorldSpace Property RiftenWorld auto
WorldSpace Property MarkarthWorld auto

; INTERNALS

; npc info stoarge
Int[] Property NPC_Affection auto hidden
actor[] Property NPC_ID auto hidden
string[] Property NPC_Personality auto hidden
string[] Property NPC_Trait1 auto hidden
string[] Property NPC_sexuality auto hidden
string[] Property NPC_relationshipStatus auto hidden
string[] Property NPC_homeHold auto hidden
float[] Property NPC_time auto hidden
float[] Property NPC_cooldown auto hidden
int[] Property NPC_earWitness auto hidden
int[] Property NPC_eyeWitness auto hidden
int[] Property NPC_cheatEyeWitness auto hidden
int[] Property NPC_cheatEarWitness auto hidden
int[] Property NPC_dialogueCount auto hidden

actor[] property playerCheatedOn auto hidden
actor[] property playerCheatedWith auto hidden
actor[] property partnerWitnessedCheating auto hidden
bool[] property wasVictim auto hidden
int property eastmarch_reputation = 100 auto hidden
int property falkreath_reputation = 100 auto hidden
int property haarfingar_reputation = 100 auto hidden
int property hjaalmarch_reputation = 100 auto hidden
int property pale_reputation = 100 auto hidden
int property reach_reputation = 100 auto hidden
int property rift_reputation = 100 auto hidden
int property whiterun_reputation = 100 auto hidden
int property winterhold_reputation = 100 auto hidden
bool property isVictim = false auto hidden
bool property foreplay = false auto hidden

; utilities
int Property first_install = 0 auto hidden
int property isCheating auto hidden
bool property isHousecarl auto hidden
actor[] property sexActors auto hidden
actor[] property nudeWitnessArray auto hidden
int property nudeWitnessCount auto hidden

Event OnInit()
	If first_install == 0
		SetUp()
		RegisterForUpdateGameTime(24)
		playerRef.addSpell(RDS_DebugSpell)
		playerRef.addSpell(RDS_BlockActorSpell)
		first_install = 1
	endIf
	RegisterForModEvent("HookAnimationStart", "HavingSex")
	RegisterForModEvent("HookAnimationEnd", "StopHavingSex")
	RegisterForModEvent("HookLeadInEnd", "ChangeingSex")
EndEvent

Event OnUpdateGameTime()			;daily actor purge
	int index = 0
	float time = Utility.GetCurrentGameTime()
	While index < 128
		If NPC_ID[index].isDead() || ((time - NPC_time[index]) >= MCM.del && MCM.del != 0)
			If NPC_ID[index].isDead() || (MCM.filteredPurge && NPC_relationshipStatus[index] == "stranger" && !NPC_ID[index].isDisabled() && NPC_earWitness[index] < 1 && NPC_eyeWitness[index] < 1 && NPC_cheatEarWitness[index] < 1 && NPC_cheatEyeWitness[index] < 1) || !MCM.filteredPurge
				int a = 128
				While a > 0
					a -= 1
					if playerCheatedOn[a] == NPC_ID[index]
						playerCheatedOn[a] = none
						playerCheatedWith[a] = none
						partnerWitnessedCheating[a] = none
						wasVictim[a] = false
					endif
				endwhile
				
				if NPC_ID[index].isInFaction(Rds_breezehome)
					NPC_ID[index].removeFromFaction(Rds_breezehome)
					PartnerWR.stop()
				elseIf  NPC_ID[index].isInFaction(Rds_hjerim)
					NPC_ID[index].removeFromFaction(Rds_hjerim)
					PartnerWH.stop()
				elseIf  NPC_ID[index].isInFaction(Rds_honeyside)
					NPC_ID[index].removeFromFaction(Rds_honeyside)
					PartnerRF.stop()
				elseIf  NPC_ID[index].isInFaction(Rds_proudspiremanor)
					NPC_ID[index].removeFromFaction(Rds_proudspiremanor)
					PartnerSO.stop()
				elseIf  NPC_ID[index].isInFaction(Rds_vlindrelhall)
					NPC_ID[index].removeFromFaction(Rds_vlindrelhall)
					PartnerMK.stop()
				endif
					
				NPC_ID[index] = none
				NPC_time[index] = 0
				NPC_Personality[index] = ""
				NPC_sexuality[index] = ""
				NPC_Trait1[index] = ""
				NPC_Affection[index] = 0
				NPC_relationshipStatus[index] = ""
				
				if NPC_homeHold[index] == "eastmarch"														;each NPC has a home hold and records reputation changes for this hold, therefore it has to be restored correctly with the NPC
					eastmarch_reputation += (NPC_eyeWitness[index] + NPC_earWitness[index])
				elseIf NPC_homeHold[index] == "falkreath"
					falkreath_reputation += (NPC_eyeWitness[index] + NPC_earWitness[index])
				elseIf NPC_homeHold[index] == "haarfingar"
					haarfingar_reputation += (NPC_eyeWitness[index] + NPC_earWitness[index])
				elseIf NPC_homeHold[index] == "hjaalmarch"
					hjaalmarch_reputation += (NPC_eyeWitness[index] + NPC_earWitness[index])
				elseIf NPC_homeHold[index] == "pale"
					pale_reputation += (NPC_eyeWitness[index] + NPC_earWitness[index])
				elseIf NPC_homeHold[index] == "reach"
					reach_reputation += (NPC_eyeWitness[index] + NPC_earWitness[index])
				elseIf NPC_homeHold[index] == "rift"
					rift_reputation += (NPC_eyeWitness[index] + NPC_earWitness[index])
				elseIf NPC_homeHold[index] == "whiterun"
					whiterun_reputation += (NPC_eyeWitness[index] + NPC_earWitness[index])
				elseIf NPC_homeHold[index] == "winterhold"
					winterhold_reputation += (NPC_eyeWitness[index] + NPC_earWitness[index])
				endif
				
				NPC_eyeWitness[index] = 0
				NPC_earWitness[index] = 0
				NPC_homeHold[index] = ""
				NPC_cheatEyeWitness[index] = -1
				NPC_cheatEarWitness[index] = -1
				NPC_cooldown[index] = 0
			endif
		endIf
		index += 1
	endwhile
endevent

Function SetUp()
		NPC_ID = new actor[128]
		NPC_Affection = new int[128]
		NPC_Personality = new String[128]
		NPC_Trait1 = new String[128]
		NPC_sexuality = new String[128]
		NPC_time = new float[128]
		NPC_relationshipStatus = new string[128]
		NPC_eyeWitness = new int[128]
		NPC_earWitness = new int[128]
		NPC_homeHold = new string[128]
		playerCheatedOn = new actor[128]
		playerCheatedWith = new actor[128]
		partnerWitnessedCheating = new actor[128]
		wasVictim = new bool[128]
		NPC_cheatEyeWitness = new int[128]
		NPC_cheatEarWitness = new int[128]
		NPC_cooldown = new float[128]
		NPC_dialogueCount = new int[128]
endfunction

function ThePurge()
	int index = 0
	While index < 128
		NPC_ID[index] = none
		NPC_time[index] = 0
		NPC_Personality[index] = ""
		NPC_sexuality[index] = ""
		NPC_Trait1[index] = ""
		NPC_Affection[index] = 0
		NPC_relationshipStatus[index] = ""
		NPC_earWitness[index] = 0
		NPC_eyeWitness[index] = 0
		NPC_homeHold[index] = ""
		playerCheatedOn[index] = none
		playerCheatedWith[index] = none
		partnerWitnessedCheating[index] = none
		wasVictim[index] = false
		NPC_cheatEyeWitness[index] = -1
		NPC_cheatEarWitness[index] = -1
		NPC_cooldown[index] = 0
		NPC_dialogueCount[index] = 0
		index += 1
	endwhile
endfunction

function purgeNPC(int index)
		NPC_ID[index] = none
		NPC_time[index] = 0
		NPC_Personality[index] = ""
		NPC_sexuality[index] = ""
		NPC_Trait1[index] = ""
		NPC_Affection[index] = 0
		NPC_relationshipStatus[index] = ""
		NPC_earWitness[index] = 0
		NPC_eyeWitness[index] = 0
		NPC_homeHold[index] = ""
		playerCheatedOn[index] = none
		playerCheatedWith[index] = none
		wasVictim[index] = false
		NPC_cheatEyeWitness[index] = -1
		NPC_cheatEarWitness[index] = -1
		NPC_cooldown[index] = 0
		NPC_dialogueCount[index] = 0
endFunction

function purgeUnusedNPC()
	int index = 0
	while index < 128
		if NPC_dialogueCount[index] < 1
			purgeNPC(index)
		endif
		index += 1
	endwhile
endFunction

Event ChangeingSex(int tid, bool hasPlayer) ;this event is fired when using the SexLab foreplay functionality

	processAnimation(tid, hasPlayer)

endEvent

Event HavingSex(int tid, bool hasPlayer)
	
	processAnimation(tid, hasPlayer)
	
endEvent

function processAnimation(int tid, bool hasPlayer)

	If hasPlayer && MCM.on

		isVictim = SexLab.isVictim(tid, playerRef)
		bool isAggressor = SexLab.IsAggressor(tid, playerRef)
		sslBaseAnimation anim = SexLab.GetController(tid).Animation
		foreplay = false
		
		if anim.hasTag("foreplay")
			foreplay = true
		else
			if !anim.hasTag("vaginal") && !anim.hasTag("anal") && !anim.hasTag("oral")
				foreplay = true
			endIf
		endIf
		
		isCheating = -1
	
		sexActors = SexLab.GetController(tid).Positions
		
		int x = sexActors.length
		int z = 0
		string relStat = ""
		
		while x > 0
			x -= 1
			z = NPC_ID.find(sexActors[x])
			
			if z == -1
				z = Main.setup_NPC(sexActors[x])
			endif
			
			if !isVictim && !isAggressor				;the npc will not like the PC better if he is the aggressor or the victim
				int affectionDummy = NPC_Affection[z]
				affectionDummy += MCM.sexAffection as int
				NPC_Affection[z] = affectionDummy
			endif
			
			relStat = NPC_relationshipStatus[z]
			
			if NPC_ID[z].isInFaction(housecarlWhiterunCrimeFaction) || NPC_ID[z].isInFaction(housecarlRiftenCrimeFaction) || NPC_ID[z].isInFaction(housecarlWindhelmCrimeFaction) || NPC_ID[z].isInFaction(housecarlSolitudeCrimeFaction) || NPC_ID[z].isInFaction(housecarlMarkarthCrimeFaction)
				isHousecarl = true
			else
				isHousecarl = false
			endif
			
			if (relStat != "lover") && (relStat != "partner") && (relStat != "friendsWithBenefits")		; set sex-partner to "lover" if it isn't already
				NPC_relationshipStatus[z] = "lover"
				
				if isVictim && MCM.victimReputation												; if the player is raped only reduce rep if toggled on
					if (NPC_ID[z].isInFaction(currentFollowerFaction) && !MCM.companionLover) || (!NPC_ID[z].isInFaction(currentFollowerFaction))
						if (isHousecarl && !MCM.housecarlLover) || (!isHousecarl)
							adjustLocalReputation(-MCM.loverReputation as int)
						endif
					endIf
				endif
			endif

			int a = 128										; checking if player is cheating
			int b = playerCheatedOn.find(none)
			string cheatinghold
			
			while a > 0	
				a -= 1
				if NPC_relationshipStatus[a] == "partner" && NPC_ID[a] != sexActors[x]				; player has a "partner" who isn't the sex-partner, so he is cheating
					playerCheatedOn[b] = NPC_ID[a]
					playerCheatedWith[b] = sexActors[x]
					if isVictim && MCM.victimCheating
						isCheating = 1
					endif
					if MCM.cheatingComments && isCheating == 1
						Debug.Notification("You just cheated on " + NPC_ID[a].getActorBase().getName() + "!")
					endif
					If isVictim
						wasVictim[b] = true
					endif
					b += 1
				endif
			endWhile
		endwhile
		
		actor player = game.getPlayer()
		cell playerCell = player.getParentCell()	
		
		scanForWitnesses(playerCell)
		
		If !Player.isInInterior()												;to cover more ground outside, the following code scans a 3x3 grid of exterior cells around the player
			ObjectReference Marker1 = Player.placeAtMe(xMarker)
			ObjectReference Marker2 = Player.placeAtMe(xMarker)			;1 2 3
			ObjectReference Marker3 = Player.placeAtMe(xMarker)			;4 0 5
			ObjectReference Marker4 = Player.placeAtMe(xMarker)			;6 7 8 
			ObjectReference Marker5 = Player.placeAtMe(xMarker)
			ObjectReference Marker6 = Player.placeAtMe(xMarker)
			ObjectReference Marker7 = Player.placeAtMe(xMarker)
			ObjectReference Marker8 = Player.placeAtMe(xMarker)

			Marker1.moveTo(Player, afXOffset = -4096.0, afYOffset = 4096.0)
			Marker2.moveTo(Player, afXOffset = 0.0, afYOffset = 4096.0)
			Marker3.moveTo(Player, afXOffset = 4096.0, afYOffset = 4096.0)

			Marker4.moveTo(Player, afXOffset = -4096.0, afYOffset = 0.0)
			Marker5.moveTo(Player, afXOffset = 4096.0, afYOffset = 0.0)

			Marker6.moveTo(Player, afXOffset = -4096.0, afYOffset = -4096.0)
			Marker7.moveTo(Player, afXOffset = 0.0, afYOffset = -4096.0)
			Marker8.moveTo(Player, afXOffset = 4096.0, afYOffset = -4096.0)
			
			scanForWitnesses(Marker1.getParentCell())
			Utility.Wait(0.5)
			scanForWitnesses(Marker2.getParentCell())
			Utility.Wait(0.5)
			scanForWitnesses(Marker3.getParentCell())
			Utility.Wait(0.5)
			scanForWitnesses(Marker4.getParentCell())
			Utility.Wait(0.5)
			scanForWitnesses(Marker5.getParentCell())
			Utility.Wait(0.5)
			scanForWitnesses(Marker6.getParentCell())
			Utility.Wait(0.5)
			scanForWitnesses(Marker7.getParentCell())
			Utility.Wait(0.5)
			scanForWitnesses(Marker8.getParentCell())
			Utility.Wait(0.5)
		endIf
	endif
endFunction

Event StopHavingSex(int tid, bool hasPlayer)
	if hasPlayer
		sexActors = new Actor[2]					; reset the actor array to empty when the animation has ended, needed for naked witness funcion
	endif
	isVictim = false
EndEvent

function scanForWitnesses(cell thisCell)
	actor thisNPC
	actor player = game.getPlayer()
	int counter = 0
	
	int iIndex = thisCell.getNumRefs(43)
	While iIndex > 0

		iIndex -= 1
		thisNPC = thisCell.getNthRef(iIndex, 43) as Actor
		
		if thisNPC.isInFaction(housecarlWhiterunCrimeFaction) || thisNPC.isInFaction(housecarlRiftenCrimeFaction) || thisNPC.isInFaction(housecarlWindhelmCrimeFaction) || thisNPC.isInFaction(housecarlSolitudeCrimeFaction) || thisNPC.isInFaction(housecarlMarkarthCrimeFaction)
			isHousecarl = true
		else
			isHousecarl = false
		endif
		
		if sexActors.find(thisNPC) < 0  						; the witness must not be the current sex partner or Companion
			if (thisNPC.isInFaction(currentFollowerFaction) && !MCM.companionWitness) || (!thisNPC.isInFaction(currentFollowerFaction))  ; NPC is: 1. companion but companions can be witnesses, or 2. he is no companion
				if (isHousecarl && !MCM.housecarlWitness) || !isHousecarl  ; NPC is housecarl but housecarls can be witnesses or he is no housecarl
					if thisNPC.hasKeyword(ActiveTypeNPC)					
						if !thisNPC.isDead() && !thisNPC.isFlying() && !thisNPC.isDisabled() && !SexLab.isActorActive(thisNPC) && !thisNPC.isHostileToActor(player) && !thisNPC.isInCombat() && thisNPC != player && thisNPC.getLeveledActorBase().getName() != ""
							if !MCM.foreplay || (MCM.foreplay && !foreplay)
								if !MCM.rapeNudeWitness || (MCM.rapeNudeWitness && !isVictim)
									if thisNPC.hasLOS(player)
										
										counter = NPC_ID.find(thisNPC)
										If counter < 0									;NPC is not set-up by RDS
											counter = Main.Setup_NPC(thisNPC)
										endif
										
										int dummy = NPC_eyeWitness[counter]
										dummy += MCM.eyeWitness as int
										NPC_eyeWitness[counter] = dummy

										adjustLocalReputation(-MCM.eyeWitness as int)
										if MCM.witnessedComments
											Debug.Notification("You were seen having sex by " + thisNPC.getLeveledActorBase().getName() + "!")
										endif
										
										if isCheating > -1
											NPC_cheatEyeWitness[counter] = isCheating
										endif
										
										if NPC_relationshipStatus[counter] == "Partner"  ;we are watched by our partner
											partnerWitnessedCheating[counter] = thisNPC
										endif
										
									elseIf thisNPC.getDistance(player) <= 209        		    ;units = 3m = 9.8ft

										counter = NPC_ID.find(thisNPC)
										If counter < 0
											counter = Main.SetUp_NPC(thisNPC)
										endif
									
										int dummy = NPC_earWitness[counter]
										dummy += MCM.earWitness as int
										NPC_earWitness[counter] = dummy

										adjustLocalReputation(-MCM.earWitness as int)
										if MCM.witnessedComments
											Debug.Notification("You were heard having sex by " + thisNPC.getLeveledActorBase().getName() + "!")
										endif

										if isCheating > -1
											NPC_cheatEarWitness[counter] = isCheating
										endif
									endif
								endif
							endif
						endif
					endif
				endIf
			endif
		endif
	endWhile
endfunction

string function getCurrentHold(actor myNPC)

	string currentHold = "unknown"
	
	if myNPC.getworldSpace() == WindhelmWorld || myNPC.IsInLocation(WindhelmLocation)
		currentHold = "eastmarch"
	elseIf myNPC.IsInLocation(FalkreathLocation)
		currentHold = "falkreath"
	elseIf myNPC.getworldSpace() == SolitudeWorld || myNPC.IsInLocation(SolitudeLocation)
		currentHold = "haarfingar"
	elseIf myNPC.IsInLocation(MorthalLocation)
		currentHold = "hjaalmarch"
	elseIf myNPC.IsInLocation(DawnstarLocation)
		currentHold = "pale"
	elseIf myNPC.getworldSpace() == MarkarthWorld || myNPC.IsInLocation(MarkarthLocation)
		currentHold = "reach"
	elseIf myNPC.getworldSpace() == RiftenWorld || myNPC.IsInLocation(RiftenLocation)
		currentHold = "rift"
	elseIf myNPC.getworldSpace() == WhiterunWorld || myNPC.IsInLocation(WhiterunLocation) || myNPC.IsInLocation(RiverwoodLocation)
		currentHold = "whiterun"
	elseIf myNPC.IsInLocation(WinterholdLocation)
		currentHold = "winterhold"
	endIf
	
	return currentHold
	
endfunction

int function getLocalReputation()

	int rep = -1
	string hold = getCurrentHold(game.GetPlayer())
	
	if hold == "eastmarch"
		rep = eastmarch_reputation
	elseIf hold == "falkreath"
		rep = falkreath_reputation
	elseIf hold == "haarfingar"
		rep = haarfingar_reputation
	elseIf hold == "hjaalmarch"
		rep = hjaalmarch_reputation
	elseIf hold == "pale"
		rep = pale_reputation
	elseIf hold == "reach"
		rep = reach_reputation
	elseIf hold == "rift"
		rep = rift_reputation
	elseIf hold == "whiterun"
		rep = whiterun_reputation
	elseIf hold == "winterhold"
		rep = winterhold_reputation
	endif
	
	return rep

endfunction

function adjustLocalReputation(int myValue)

	string hold = getCurrentHold(game.getPlayer())
	
	if hold == "eastmarch"
		eastmarch_reputation += myValue
		capRep(eastmarch_reputation, hold)
		
	elseIf hold == "falkreath"
		falkreath_reputation += myValue		
		capRep(falkreath_reputation, hold)
		
	elseIf hold == "haarfingar"
		haarfingar_reputation += myValue
		capRep(haarfingar_reputation, hold)
		
	elseIf hold == "hjaalmarch"
		hjaalmarch_reputation += myValue
		capRep(hjaalmarch_reputation, hold)
		
	elseIf hold == "pale"
		pale_reputation += myValue
		capRep(pale_reputation, hold)
		
	elseIf hold == "reach"
		reach_reputation += myValue
		capRep(reach_reputation, hold)
		
	elseIf hold == "rift"
		rift_reputation += myValue
		capRep(rift_reputation, hold)
		
	elseIf hold == "whiterun"
		whiterun_reputation += myValue
		capRep(whiterun_reputation, hold)
		
	elseIf hold == "winterhold"
		winterhold_reputation += myValue
		capRep(winterhold_reputation, hold)
		
	endif

	
	if MCM.reputationStatusComments
		int rep = getLocalReputation()
		if rep == 100
			Debug.Notification("You are seen as innocent!")
		elseif rep > 75
			Debug.Notification("You are recognized as faithful!")		
		elseif rep > 50
			Debug.Notification("You are known to be playful!")
		elseif rep > 25
			Debug.Notification("You are infamous for being adventurous!")
		elseif rep > 0
			Debug.Notification("People disrespect you as unfaithful!")
		elseif rep == 0
			Debug.Notification("Everyone despises you as a whore!")
		endif
	endif
	
endfunction

int function capRep(int myRep, string hold)
	
	if myRep > 100
		myRep = 100
	elseIf myRep < 0
		myRep = 0
	endIf
	
	if hold == "eastmarch"
		eastmarch_reputation = myRep	
	elseIf hold == "falkreath"
		falkreath_reputation = myRep		
	elseIf hold == "haarfingar"
		haarfingar_reputation = myRep
	elseIf hold == "hjaalmarch"
		hjaalmarch_reputation = myRep
	elseIf hold == "pale"
		pale_reputation = myRep
	elseIf hold == "reach"
		reach_reputation = myRep
	elseIf hold == "rift"
		rift_reputation = myRep
	elseIf hold == "whiterun"
		whiterun_reputation = myRep
	elseIf hold == "winterhold"
		winterhold_reputation = myRep
	endif
	
endFunction

Event OnUpdate()																					;script on alias has detected that the player is naked, start polling for witnesses. Poll is ended only the player is clothed again.
	if MCM.on && MCM.nudeWitness > 0.0 && playerArmorScript.nudeCheck()								; turn off the nude scan if the mod is turned off while already naked
		if !SexLab.isActorActive(playerRef)															; skip nude witnesses when player is haveing sex, so we don't have nude and sex witnesses at the same time
			handleNakedLOS()
		endif
	else
		playerArmorScript.nudeScanActive = false
		UnregisterForUpdate()
	endif
endEvent

Function handleNakedLOS()

	cell playerCell = playerRef.getParentCell()	
	scanForNakedLOS(playerCell)
	
	if !playerRef.isInInterior()
		ObjectReference Marker1 = playerRef.placeAtMe(xMarker)
		ObjectReference Marker2 = playerRef.placeAtMe(xMarker)			;1 2 3
		ObjectReference Marker3 = playerRef.placeAtMe(xMarker)			;4 0 5
		ObjectReference Marker4 = playerRef.placeAtMe(xMarker)			;6 7 8 
		ObjectReference Marker5 = playerRef.placeAtMe(xMarker)
		ObjectReference Marker6 = playerRef.placeAtMe(xMarker)
		ObjectReference Marker7 = playerRef.placeAtMe(xMarker)
		ObjectReference Marker8 = playerRef.placeAtMe(xMarker)

		Marker1.moveTo(playerRef, afXOffset = -4096.0, afYOffset = 4096.0)
		Marker2.moveTo(playerRef, afXOffset = 0.0, afYOffset = 4096.0)
		Marker3.moveTo(playerRef, afXOffset = 4096.0, afYOffset = 4096.0)

		Marker4.moveTo(playerRef, afXOffset = -4096.0, afYOffset = 0.0)
		Marker5.moveTo(playerRef, afXOffset = 4096.0, afYOffset = 0.0)

		Marker6.moveTo(playerRef, afXOffset = -4096.0, afYOffset = -4096.0)
		Marker7.moveTo(playerRef, afXOffset = 0.0, afYOffset = -4096.0)
		Marker8.moveTo(playerRef, afXOffset = 4096.0, afYOffset = -4096.0)
		
		scanForNakedLOS(Marker1.getParentCell())
		Utility.Wait(0.25)
		scanForNakedLOS(Marker2.getParentCell())
		Utility.Wait(0.25)
		scanForNakedLOS(Marker3.getParentCell())
		Utility.Wait(0.25)
		scanForNakedLOS(Marker4.getParentCell())
		Utility.Wait(0.25)
		scanForNakedLOS(Marker5.getParentCell())
		Utility.Wait(0.25)
		scanForNakedLOS(Marker6.getParentCell())
		Utility.Wait(0.25)
		scanForNakedLOS(Marker7.getParentCell())
		Utility.Wait(0.25)
		scanForNakedLOS(Marker8.getParentCell())
		Utility.Wait(0.25)
	endif
endfunction

Function scanForNakedLOS(cell thisCell)
	actor thisNPC = none
	int iIndex = thisCell.getNumRefs(43)
	string RS = ""

	While iIndex > 0
		iIndex -= 1
		thisNPC = thisCell.getNthRef(iIndex, 43) as Actor
		if thisNPC.hasKeyword(ActiveTypeNPC) && thisNPC != playerRef && (nudeWitnessArray.find(thisNPC) < 0) && thisNPC.getLeveledActorBase().getName() != ""
			int X = NPC_ID.find(thisNPC)
			if X > -1
				RS = NPC_relationshipStatus[X]
			endif
			if RS != "partner" && RS != "friendsWithBenefits"
				if (sexActors.find(thisNPC) < 0)
					if thisNPC.hasLOS(playerRef)
						adjustLocalReputation(-MCM.nudeWitness as int)
						
						nudeWitnessArray[nudeWitnessCount] = thisNPC
						nudeWitnessCount += 1
						
						if MCM.reputationStatusComments
							Debug.Notification("You have been spotted naked by " + thisNPC.getLeveledActorBase().getName() + "!")
						endif
						if nudeWitnessCount == 127				; if the witness array is full, reset it. This is a precaution. The witness array prevents the same npc to witness the player multiple times in a short time
							nudeWitnessArray = new Actor[128]
							nudeWitnessCount = 0
						endif
					endif
				endif
			endif
		endif
	endwhile
endFunction
