Scriptname RDS_PrisonScript extends Quest conditional

;CONSTANTS
objectReference Property Marker_Whiterun auto
objectReference Property Marker_Windhelm auto
objectReference Property Marker_Riften auto
objectReference Property Marker_Solitude auto
objectReference Property Door_Whiterun auto
objectReference Property Door_Windhelm auto
objectReference Property Door_Riften auto
objectReference Property Door_Solitude auto
SexlabFramework Property Sexlab auto
referenceAlias Property partner auto
GlobalVariable Property RDS_Fine  Auto  
RDS_PlayerApproachScript Property Main auto
referenceAlias Property partner_WR auto
referenceAlias Property partner_WH auto
referenceAlias Property partner_RF auto
referenceAlias Property partner_SO auto
referenceAlias Property partner_MK auto
quest property RDS_HomeBreezehomeQuest auto
quest property RDS_HomeHjerimQuest auto
quest property RDS_HomeHoneysideQuest auto
quest property RDS_HomeProudspireManorQuest auto
quest property RDS_HomeVlindrelHallQuest auto

;INTERNALS
int Property loc auto hidden conditional
int property fine auto hidden conditional

Function SetUp()
	
	loc = Utility.RandomInt(1,4)
	fine = Utility.RandomInt(500, 3500)
	RDS_Fine.setValue(fine)
	
	RegisterForUpdateGameTime(24)

	if loc == 1
		partner.getRef().moveTo(Marker_Whiterun)
		Door_Whiterun.lock()
	elseIf loc == 2
		partner.getRef().moveTo(Marker_Windhelm)
		Door_Windhelm.lock()
	elseIf loc == 3
		partner.getRef().moveTo(Marker_Riften)
		Door_Riften.lock()
	else
		partner.getRef().moveTo(Marker_Solitude)
		Door_Solitude.lock()
	endif	

	SetStage(10)

EndFunction

Function Action(actor lover)
	RegisterForModEvent("AnimationEnd_Prison", "Prison")

		actor[] sexActors = new actor[2]

		if SexLab.getGender(Game.getPlayer()) == 1 || SexLab.getGender(Game.getPlayer()) == SexLab.getGender(lover)
			sexActors[0] = Game.getPlayer()
			sexActors[1] = lover	
		else
			sexActors[0] = lover
			sexActors[1] = Game.getPlayer()
		endif

		sslBaseAnimation[] anims		

		SexLab.StartSex(SexActors, Anims, AllowBed = true ,Hook = "Prison")

endfunction

event Prison (string eventName, string argString, float argNum, form sender)
	fine = (fine * 0.8) as int
	RDS_Fine.setValue(fine)
	if getStage() == 10
		setStage(20)
	elseif getStage() > 10
		setStage(40)
	endif
endEvent

Function Unlock_WR()
	Door_Whiterun.lock(false, true)
endFunction

Function Unlock_WH()
	Door_Whiterun.lock(false, true)
endFunction

Function Unlock_RF()
	Door_Whiterun.lock(false, true)
endFunction

Function Unlock_SO()
	Door_Whiterun.lock(false, true)
endFunction

Event OnUpdateGameTime()

	int NPC = main.NPC_ID.find(partner.getActorRef())
	int affection = main.NPC_affection[NPC]
	affection -= 2
	main.NPC_affection[NPC] = affection
	
endEvent

function setPartnerHome()
	actor myPartner = partner.getActorRef()
	
	if myPartner == partner_WR.getActorRef()
		RDS_HomeBreezehomeQuest.setStage(40)
	elseif myPartner == partner_WH.getActorRef()
		RDS_HomeHjerimQuest.setStage(40)
	elseif myPartner == partner_RF.getActorRef()
		RDS_HomeHoneysideQuest.setStage(40)
	elseif myPartner == partner_SO.getActorRef()
		RDS_HomeProudspireManorQuest.setStage(40)
	elseif myPartner == partner_MK.getActorRef()
		RDS_HomeVlindrelHallQuest.setStage(40)
	endif

endFunction