Scriptname RDS_RelationshipScript extends Quest conditional

;CONSTANTS
SexLabFramework property SexLab auto
RDS_playerApproachScript property main auto
actor property playerRef auto
referenceAlias property activePartner auto
miscObject property gold001 auto
Quest property RDS_meal auto
referenceAlias property whiterunPartner auto
referenceAlias property windhelmPartner auto
referenceAlias property riftenPartner auto
referenceAlias property solitudePartner auto
referenceAlias property markarthPartner auto
faction property RDS_breezehome auto
faction property RDS_Hjerim auto
faction property RDS_Honeyside auto
faction property RDS_ProudspireManor auto
faction property RDS_VlindrelHall auto
quest property RDS_HomeBreezehomeQuest auto
quest property RDS_HomeHjerimQuest auto
quest property RDS_HomeHoneysideQuest auto
quest property RDS_HomeProudspireManorQuest auto
quest property RDS_HomeVlindrelHallQuest auto
potion property meal01 auto
potion property meal02 auto
potion property meal03 auto
faction property RDS_partner auto
RDS_MCM property MCM auto
referenceAlias property PartnerWR auto
referenceAlias property PartnerWH auto
referenceAlias property PartnerRF auto
referenceAlias property PartnerSO auto
referenceAlias property PartnerMK auto
quest property prisonQuest auto
referenceAlias property prisonPartner auto
objectReference[] property dirtElement auto


;INTERNALS         0=Eastmarch 1=Falkreath 2=Haafingar 3=Hjaalmarch 4=ThePale 5=TheReach 6=TheRift 7=Whiterun 8=Winterhold
bool property doOnce = false auto hidden
actor property Partner_Eastmarch auto hidden conditional
actor property Partner_Falkreath auto hidden conditional
actor property Partner_Haafingar auto hidden conditional
actor property Partner_Hjaalmarch auto hidden conditional
actor property Partner_ThePale auto hidden conditional
actor property Partner_TheReach auto hidden conditional
actor property Partner_TheRift auto hidden conditional
actor property Partner_Whiterun auto hidden conditional
actor property Partner_Winterhold auto hidden conditional
bool property breakup_Eastmarch = false auto hidden conditional
bool property breakup_Falkreath = false auto hidden conditional
bool property breakup_Haafingar = false auto hidden conditional
bool property breakup_Hjaalmarch = false auto hidden conditional
bool property breakup_ThePale = false auto hidden conditional
bool property breakup_TheReach = false auto hidden conditional
bool property breakup_TheRift = false auto hidden conditional
bool property breakup_Whiterun = false auto hidden conditional
bool property breakup_Winterhold = false auto hidden conditional
float property RelTime_Eastmarch = 0.0 auto hidden
float property RelTime_Falkreath = 0.0 auto hidden
float property RelTime_Haafingar = 0.0 auto hidden
float property RelTime_Hjaalmarch = 0.0 auto hidden
float property RelTime_ThePale = 0.0 auto hidden
float property RelTime_TheReach = 0.0 auto hidden
float property RelTime_TheRift = 0.0 auto hidden
float property RelTime_Whiterun = 0.0 auto hidden
float property RelTime_Winterhold = 0.0 auto hidden
bool property rough = false auto hidden conditional
int property partnerGender auto hidden conditional
int property playerGender auto hidden conditional
float property myTime auto hidden
int property partnerPersonality auto hidden conditional
int property partnerReputation auto hidden conditional
string property demandQuest auto hidden
Bool Property partnerWon  Auto Hidden 
bool property whiterunTravel = false auto hidden
bool property windhelmTravel = false auto hidden
bool property riftenTravel = false auto hidden
bool property solitudeTravel = false auto hidden
bool property markarthTravel = false auto hidden
string property demand = "" auto hidden


Event OnInit()
	If !doOnce
		RegisterForUpdateGameTime(24)
		doOnce = true
	endif
endEvent

Function Action()
	RegisterForModEvent("AnimationEnd_withPartner", "Finished")

		actor[] sexActors = new actor[2]

		if playerGender == 1 || playerGender == partnerGender
			sexActors[0] = playerRef
			sexActors[1] = (ActivePartner.getRef() as Actor)	
		else													; and vice versa
			sexActors[0] = (ActivePartner.getRef() as Actor)
			sexActors[1] = playerRef
		endif

		sslBaseAnimation[] anims		

	If rough
		anims = SexLab.GetAnimationsByTags(2, "Aggressive", RequireAll = false)
		SexLab.StartSex(SexActors, Anims, AllowBed = true, Hook = "withPartner")
	else
		SexLab.StartSex(SexActors, Anims, AllowBed = true, Hook = "withPartner")
	endif
endfunction

Function updateSex(actor partner)
	partnerGender = SexLab.getGender(partner) ; 0 = male, 1 = female
	playerGender = SexLab.getGender(playerRef)
endfunction

event Finished (string eventName, string argString, float argNum, form sender)
	rough = false
	unregisterForUpdate()
	activePartner.clear()
	setStage(200)
endEvent

Event OnUpdate()
	if (Utility.getCurrentGameTime() - myTime) > 3 && getStage() > 0 && getStage() < 50
		setStage(200)
	elseIf (Utility.getCurrentGameTime() - myTime) > 2 && getStage() == 55
		partnerWon = false
		setStage(58)
	endif
endEvent

Event OnUpdateGameTime()
if MCM.on
	int NPC
	string Personality
	if Partner_Eastmarch != none
		NPC = main.NPC_ID.find(Partner_Eastmarch)
		Personality = main.NPC_Personality[NPC]
		if (Utility.getCurrentGameTime() - RelTime_Eastmarch) > 5
			if main.NPC_affection[NPC] < 80 
				breakup_Eastmarch = true
			elseif Personality == "choleric"
				if main.Eastmarch_reputation > 74
					breakup_Eastmarch = true
				endif			
			elseif Personality == "shy"
				if main.Eastmarch_reputation < 26
					breakup_Eastmarch = true
				endif
			else
				RelTime_Eastmarch += 5
			endif
		endif
	endif
	if Partner_Falkreath != none
		NPC = main.NPC_ID.find(Partner_Falkreath)
		Personality = main.NPC_Personality[NPC]
		if (Utility.getCurrentGameTime() - RelTime_Falkreath) > 5
			if main.NPC_affection[NPC] < 80
				breakup_Falkreath = true
			elseif Personality == "choleric"
				if main.Falkreath_reputation > 74
					breakup_Falkreath = true
				endif			
			elseif Personality == "shy"
				if main.Falkreath_reputation < 26
					breakup_Falkreath = true
				endif
			else
				RelTime_Falkreath += 5
			endif
		endif
	endif
	if Partner_Haafingar != none
		NPC = main.NPC_ID.find(Partner_Haafingar)
		Personality = main.NPC_Personality[NPC]
		if (Utility.getCurrentGameTime() - RelTime_Haafingar) > 5
			if main.NPC_affection[NPC] < 80
				breakup_Haafingar = true
			elseif Personality == "choleric"
				if main.Haarfingar_reputation > 74
					breakup_Haafingar = true
				endif			
			elseif Personality == "shy"
				if main.Haarfingar_reputation < 26
					breakup_Haafingar = true
				endif
			else
				RelTime_Haafingar += 5
			endif
		endif
	endif
	if Partner_Hjaalmarch != none
		NPC = main.NPC_ID.find(Partner_Hjaalmarch)
		Personality = main.NPC_Personality[NPC]
		if (Utility.getCurrentGameTime() - RelTime_Hjaalmarch) > 5
			if main.NPC_affection[NPC] < 80
				breakup_Hjaalmarch = true
			elseif Personality == "choleric"
				if main.Hjaalmarch_reputation > 74
					breakup_Hjaalmarch = true
				endif			
			elseif Personality == "shy"
				if main.Hjaalmarch_reputation < 26
					breakup_Hjaalmarch = true
				endif
			else
				RelTime_Hjaalmarch += 5
			endif
		endif
	endif
	if Partner_ThePale != none
		NPC = main.NPC_ID.find(Partner_ThePale)
		Personality = main.NPC_Personality[NPC]
		if (Utility.getCurrentGameTime() - RelTime_ThePale) > 5
			if main.NPC_affection[NPC] < 80
				breakup_ThePale = true
			elseif Personality == "choleric"
				if main.Pale_reputation > 74
					breakup_ThePale = true
				endif			
			elseif Personality == "shy"
				if main.Pale_reputation < 26
					breakup_ThePale = true
				endif
			else
				RelTime_ThePale += 5
			endif
		endif
	endif
	if Partner_TheReach != none
		NPC = main.NPC_ID.find(Partner_TheReach)
		Personality = main.NPC_Personality[NPC]
		if (Utility.getCurrentGameTime() - RelTime_TheReach) > 5
			if main.NPC_affection[NPC] < 80
				breakup_TheReach = true
			elseif Personality == "choleric"
				if main.Reach_reputation > 74
					breakup_TheReach = true
				endif			
			elseif Personality == "shy"
				if main.Reach_reputation < 26
					breakup_TheReach = true
				endif
			else
				RelTime_TheReach += 5
			endif
		endif
	endif
	if Partner_TheRift != none
		NPC = main.NPC_ID.find(Partner_TheRift)
		Personality = main.NPC_Personality[NPC]
		if (Utility.getCurrentGameTime() - RelTime_TheRift) > 5
			if main.NPC_affection[NPC] < 80
				breakup_TheRift = true
			elseif Personality == "choleric"
				if main.Rift_reputation > 74
					breakup_TheRift = true
				endif			
			elseif Personality == "shy"
				if main.Rift_reputation < 26
					breakup_TheRift = true
				endif
			else
				RelTime_TheRift += 5
			endif
		endif
	endif
	if Partner_Whiterun != none
		NPC = main.NPC_ID.find(Partner_Whiterun)
		Personality = main.NPC_Personality[NPC]
		if (Utility.getCurrentGameTime() - RelTime_Whiterun) > 5
			if main.NPC_affection[NPC] < 80
				breakup_Whiterun = true
			elseif Personality == "choleric"
				if main.Whiterun_reputation > 74
					breakup_Whiterun = true
				endif			
			elseif Personality == "shy"
				if main.Whiterun_reputation < 26
					breakup_Whiterun = true
				endif
			else
				RelTime_Whiterun += 5
			endif
		endif
	endif
	if Partner_Winterhold != none
		NPC = main.NPC_ID.find(Partner_Winterhold)
		Personality = main.NPC_Personality[NPC]
		if (Utility.getCurrentGameTime() - RelTime_Winterhold) > 5
			if main.NPC_affection[NPC] < 80
				breakup_Winterhold = true
			elseif Personality == "choleric"
				if main.Winterhold_reputation > 74
					breakup_Winterhold = true
				endif			
			elseif Personality == "shy"
				if main.Winterhold_reputation < 26
					breakup_Winterhold = true
				endif
			else
				RelTime_Winterhold += 5
			endif
		endif
	endif
endif
endEvent

Function newPartner(actor partner)

	int NPC = main.NPC_ID.find(partner)
		
	if main.NPC_homeHold[NPC] == "eastmarch"
		Partner_Eastmarch = partner
		RelTime_Eastmarch = Utility.getCurrentGameTime()
	elseif main.NPC_homeHold[NPC] == "falkreath"
		Partner_Falkreath = partner
		RelTime_Falkreath = Utility.getCurrentGameTime()
	elseif main.NPC_homeHold[NPC] == "haarfingar"
		Partner_Haafingar = partner
		RelTime_Haafingar = Utility.getCurrentGameTime()
	elseif main.NPC_homeHold[NPC] == "hjaalmarch"
		Partner_Hjaalmarch = partner
		RelTime_Hjaalmarch = Utility.getCurrentGameTime()
	elseif main.NPC_homeHold[NPC] == "pale"
		Partner_ThePale = partner
		RelTime_ThePale = Utility.getCurrentGameTime()
	elseif main.NPC_homeHold[NPC] == "reach"
		Partner_TheReach = partner
		RelTime_TheReach = Utility.getCurrentGameTime()
	elseif main.NPC_homeHold[NPC] == "rift"
		Partner_TheRift = partner
		RelTime_TheRift = Utility.getCurrentGameTime()
	elseif main.NPC_homeHold[NPC] == "whiterun"
		Partner_Whiterun = partner
		RelTime_Whiterun = Utility.getCurrentGameTime()
	elseif main.NPC_homeHold[NPC] == "winterhold"
		Partner_Winterhold = partner
		RelTime_Winterhold = Utility.getCurrentGameTime()
	endif
	
	main.NPC_RelationshipStatus[NPC] = "partner"
	
endFunction

Function breakupPartner(actor partner)

	int NPC = main.NPC_ID.find(partner)
		
	if main.NPC_homeHold[NPC] == "eastmarch"
		Partner_Eastmarch = none
	elseif main.NPC_homeHold[NPC] == "falkreath"
		Partner_Falkreath = none
	elseif main.NPC_homeHold[NPC] == "haarfingar"
		Partner_Haafingar = none
	elseif main.NPC_homeHold[NPC] == "hjaalmarch"
		Partner_Hjaalmarch = none
	elseif main.NPC_homeHold[NPC] == "pale"
		Partner_ThePale = none
	elseif main.NPC_homeHold[NPC] == "reach"
		Partner_TheReach = none
	elseif main.NPC_homeHold[NPC] == "rift"
		Partner_TheRift = none
	elseif main.NPC_homeHold[NPC] == "whiterun"
		Partner_Whiterun = none
	elseif main.NPC_homeHold[NPC] == "winterhold"
		Partner_Winterhold = none
	endif
	
	partner.removeFromFaction(RDS_partner)
	main.NPC_RelationshipStatus[NPC] = "expartner"
	moveOut(partner)
	Debug.Notification("You just broke up with " + partner.getLeveledActorBase().getName() + "!")
	
endFunction

function setAffection(int modifier, actor partner)

	int NPC = main.NPC_ID.find(partner)
	int affection = main.NPC_Affection[NPC]
	
	affection += modifier
	
	if affection > 100
		affection == 100
	elseif affection < -100
		affection == -100
	endif
	
	main.NPC_Affection[NPC] = affection 
	
	Int Rank
	If Affection <= -100
		Rank = -4
	elseIf Affection <= -60
		Rank = -3
	elseIf Affection <= -30
		Rank = -2
	elseIf Affection <= -10
		Rank = -1
	endif
	If Affection >= 100
		Rank = 4
	elseIf Affection >= 60
		Rank = 3
	elseIf Affection >= 30
		Rank = 2
	elseIf Affection >= 10
		Rank = 1
	endif
	
	partner.SetRelationshipRank(playerRef, Rank)

endFunction

function updateConditions(actor partner)
	
	int NPC = main.NPC_ID.find(partner)
	string pers = main.NPC_Personality[NPC]
	
	if pers == "choleric"
		partnerPersonality = 1
	elseIf pers == "confidant"
		partnerPersonality = 2
	elseIf pers == "realistic"
		partnerPersonality = 3
	elseIf pers == "shy"
		partnerPersonality = 4
	else
		partnerPersonality = 5
	endIf
	
	string hold = main.NPC_homeHold[NPC]
	
	if hold == "eastmarch"
		partnerReputation = main.eastmarch_reputation
	elseif hold == "falkreath"
		partnerReputation = main.falkreath_reputation
	elseif hold == "haarfingar"
		partnerReputation = main.haarfingar_reputation
	elseif hold == "hjaalmarch"
		partnerReputation = main.hjaalmarch_reputation
	elseif hold == "pale"
		partnerReputation = main.pale_reputation
	elseif hold == "reach"
		partnerReputation = main.reach_reputation
	elseif hold == "rift"
		partnerReputation = main.rift_reputation
	elseif hold == "whiterun"
		partnerReputation = main.whiterun_reputation
	elseif hold == "winterhold"
		partnerReputation = main.winterhold_reputation
	endif
	
endFunction

function chooseTopic(actor partner)

	int NPC = main.NPC_ID.find(partner)
	string hold = main.NPC_homeHold[NPC]
	bool breakup = false
	bool cheating = false
	
	if prisonQuest.isRunning() && partner == prisonPartner.getActorRef()
		setStage(200)	
	else
	
		if hold == "eastmarch"
			breakup = breakup_Eastmarch
		elseif hold == "falkreath"
			breakup = breakup_Falkreath
		elseif hold == "haarfingar"
			breakup = breakup_Haafingar
		elseif hold == "hjaalmarch"
			breakup = breakup_Hjaalmarch
		elseif hold == "pale"
			breakup = breakup_ThePale
		elseif hold == "reach"
			breakup = breakup_TheReach
		elseif hold == "rift"
			breakup = breakup_TheRift
		elseif hold == "whiterun"
			breakup = breakup_Whiterun
		elseif hold == "winterhold"
			breakup = breakup_Winterhold
		endif
		
		bool startTraveling = false
		
		if RDS_HomeBreezehomeQuest.isRunning() && partner == whiterunPartner.getActorRef()
			startTraveling = whiterunTravel
		elseIf RDS_HomeHjerimQuest.isRunning() && partner == windhelmPartner.getActorRef()
			startTraveling = windhelmTravel	
		elseIf RDS_HomeHoneysideQuest.isRunning() && partner == riftenPartner.getActorRef()
			startTraveling = riftenTravel
		elseIf RDS_HomeProudspireManorQuest.isRunning() && partner == solitudePartner.getActorRef()
			startTraveling = solitudeTravel
		elseIf RDS_HomeVlindrelHallQuest.isRunning() && partner == markarthPartner.getActorRef()
			startTraveling = markarthTravel
		endif

		if !breakup
			int x = 128
			while x > 0
				x -= 1
				if partner == main.partnerWitnessedCheating[x]
					cheating = true
					main.partnerWitnessedCheating[x] = none
					x = 0
				endIf
			endWhile
		endIf

		if breakup
			setStage(40)	; breakup
		elseIf cheating
			setStage(45)	; confrontation
		elseIf startTraveling
			setStage(50)	; leaving
		else
			int random = Utility.RandomInt(1, 100)
			if random > 66
				setStage(10)	; complain
			elseIf random > 33
				setStage(20)	; compliment
			else
				setStage(30)	; demand
			endif
		endif
	endif
endFunction

function demand(actor partner)
	if demandQuest == "sex"
		setStage(60)
	elseif demandQuest == "meal"
		RDS_meal.start()
		setStage(200)
	else
		int g = playerRef.getItemCount(Gold001)
		int a
		if g >= 500
			a = Utility.RandomInt(300, 500)
			playerRef.removeItem(Gold001, a)
			partner.addItem(Gold001, a)
			setStage(200)
		elseif g > 0
			a = Utility.RandomInt(1, g)
			playerRef.removeItem(Gold001, a)
			partner.addItem(Gold001, a)
			setStage(200)
		endif
	endif
endFunction

Function moveOut(actor Partner)

	if whiterunPartner.getActorRef() == partner
		partner.removeFromFaction(RDS_breezehome)
		RDS_HomeBreezehomeQuest.stop()
		PartnerWR.clear()
	elseif windhelmPartner.getActorRef() == partner
		partner.removeFromFaction(RDS_Hjerim)
		RDS_HomeHjerimQuest.stop()
		PartnerWH.clear()
	elseif riftenPartner.getActorRef() == partner
		partner.removeFromFaction(RDS_Honeyside)
		RDS_HomeHoneysideQuest.stop()		
		PartnerRF.clear()
	elseif solitudePartner.getActorRef() == partner
		partner.removeFromFaction(RDS_ProudspireManor)
		RDS_HomeProudspireManorQuest.stop()
		PartnerSO.clear()
	elseif markarthPartner.getActorRef() == partner
		partner.removeFromFaction(RDS_VlindrelHall)
		RDS_HomeVlindrelHallQuest.stop()
		PartnerMK.clear()
	endif

endFunction

Function partnerHasLeft(actor partner)

	if partner == whiterunPartner.getActorRef()
		whiterunTravel = false
		RDS_HomeBreezehomeQuest.setStage(30)
	elseIf partner == windhelmPartner.getActorRef()
		windhelmTravel = false
		RDS_HomeHjerimQuest.setStage(30)
	elseIf partner == riftenPartner.getActorRef()
		riftenTravel = false
		RDS_HomeHoneysideQuest.setStage(30)
	elseIf partner == solitudePartner.getActorRef()
		solitudeTravel = false
		RDS_HomeProudspireManorQuest.setStage(30)
	elseIf partner == markarthPartner.getActorRef()
		markarthTravel = false
		RDS_HomeVlindrelHallQuest.setStage(30)
	endif

endFunction

function playerDemand()

	if demand == "meal"
		int random = utility.randomInt(1,3)
		if random == 1
			playerRef.additem(meal01, 1)
		elseIf random == 2
			playerRef.additem(meal02, 1)
		else
			playerRef.additem(meal03, 1)
		endif
	elseIf demand == "gold"
		int amount = utility.randomInt(45, 500)
		playerRef.addItem(gold001, amount)
	endif	

	setStage(200)

endFunction

Function disableDirt()
	int index = dirtElement.Length
	while index > 0
		index -= 1
		dirtElement[index].disable()
	endWhile
endFunction

Function enableDirt()
	int index = dirtElement.Length
	while index > 0
		index -= 1
		dirtElement[index].enable()
	endWhile
endFunction












